searchNodes=[{"ref":"Mix.Tasks.Gh.Docs.html","title":"Mix.Tasks.Gh.Docs","type":"task","doc":"Task that pushes docs to gh-pages branch on Discord."},{"ref":"Mix.Tasks.Gh.Docs.html#run/1","title":"Mix.Tasks.Gh.Docs.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Nostrum.Consumer.html","title":"Nostrum.Consumer","type":"behaviour","doc":"Consumer process for gateway event handling. Consuming Gateway Events To handle events, Nostrum uses a GenStage implementation. Nostrum defines the producer and producer_consumer in the GenStage design. To consume the events you must create at least one consumer process. It is generally recommended that you spawn a consumer per core. To find this number you can use System.schedulers_online/0. Nostrum uses a ConsumerSupervisor to dispatch events, meaning your handlers will each be ran in their own seperate task. Example An example consumer can be found here."},{"ref":"Nostrum.Consumer.html#c:handle_event/1","title":"Nostrum.Consumer.handle_event/1","type":"callback","doc":"Callback used to handle events. Event event is a tuple describing the event. The tuple will include information in the following format: {event_name, {event_payload(s)}, WSState.t} For example, a message create will look like this {:MESSAGE_CREATE, {Nostrum.Struct.Message.t}, WSState.t} In some cases there will be multiple payloads when something is updated, so as to include the new and the old versions. In the event of there being two payloads, the old payload will always be first, followed by the new payload. {:USER_UPDATE, {old_user :: Nostrum.Struct.User.t, new_user :: Nostrum.Struct.User.t}, WSState.t()} For a full listing of events, please see Nostrum.Consumer.event/0."},{"ref":"Nostrum.Consumer.html#start_link/2","title":"Nostrum.Consumer.start_link/2","type":"function","doc":"Starts a consumer process. mod is the name of the module where you define your event callbacks, which should probably be the current module which you can get with __MODULE__. options is a list of general process options. See Nostrum.Consumer.options/0 for more info."},{"ref":"Nostrum.Consumer.html#t:channel_create/0","title":"Nostrum.Consumer.channel_create/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:channel_delete/0","title":"Nostrum.Consumer.channel_delete/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:channel_pins_ack/0","title":"Nostrum.Consumer.channel_pins_ack/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:channel_pins_update/0","title":"Nostrum.Consumer.channel_pins_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:channel_update/0","title":"Nostrum.Consumer.channel_update/0","type":"type","doc":"Dispatched when a channel is updated. old_channel will be nil when the pre-update channel could not be fetched from the cache."},{"ref":"Nostrum.Consumer.html#t:event/0","title":"Nostrum.Consumer.event/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_available/0","title":"Nostrum.Consumer.guild_available/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_ban_add/0","title":"Nostrum.Consumer.guild_ban_add/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_ban_remove/0","title":"Nostrum.Consumer.guild_ban_remove/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_create/0","title":"Nostrum.Consumer.guild_create/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_delete/0","title":"Nostrum.Consumer.guild_delete/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_emojis_update/0","title":"Nostrum.Consumer.guild_emojis_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_integrations_update/0","title":"Nostrum.Consumer.guild_integrations_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_member_add/0","title":"Nostrum.Consumer.guild_member_add/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_member_remove/0","title":"Nostrum.Consumer.guild_member_remove/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_member_update/0","title":"Nostrum.Consumer.guild_member_update/0","type":"type","doc":"Dispatched when a guild member is updated. old_member will be nil when the pre-update member could not be fetched from the cache."},{"ref":"Nostrum.Consumer.html#t:guild_members_chunk/0","title":"Nostrum.Consumer.guild_members_chunk/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_role_create/0","title":"Nostrum.Consumer.guild_role_create/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_role_delete/0","title":"Nostrum.Consumer.guild_role_delete/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_role_update/0","title":"Nostrum.Consumer.guild_role_update/0","type":"type","doc":"Dispatched when a role on a guild is updated. old_role will be nil when the pre-update role could not be fetched from the cache."},{"ref":"Nostrum.Consumer.html#t:guild_unavailable/0","title":"Nostrum.Consumer.guild_unavailable/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:guild_update/0","title":"Nostrum.Consumer.guild_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_ack/0","title":"Nostrum.Consumer.message_ack/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_create/0","title":"Nostrum.Consumer.message_create/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_delete/0","title":"Nostrum.Consumer.message_delete/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_delete_bulk/0","title":"Nostrum.Consumer.message_delete_bulk/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_reaction_add/0","title":"Nostrum.Consumer.message_reaction_add/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_reaction_remove/0","title":"Nostrum.Consumer.message_reaction_remove/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_reaction_remove_all/0","title":"Nostrum.Consumer.message_reaction_remove_all/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:message_update/0","title":"Nostrum.Consumer.message_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:option/0","title":"Nostrum.Consumer.option/0","type":"type","doc":"General process options. The subscribe_to option should only be set if you want to use your own producer or producer consumer."},{"ref":"Nostrum.Consumer.html#t:options/0","title":"Nostrum.Consumer.options/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:presence_update/0","title":"Nostrum.Consumer.presence_update/0","type":"type","doc":"Dispatched when a user&#39;s presence is updated. old_presence will be nil when the pre-update presence could not be fetched from the cache."},{"ref":"Nostrum.Consumer.html#t:ready/0","title":"Nostrum.Consumer.ready/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:resumed/0","title":"Nostrum.Consumer.resumed/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:typing_start/0","title":"Nostrum.Consumer.typing_start/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:user_settings_update/0","title":"Nostrum.Consumer.user_settings_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:user_update/0","title":"Nostrum.Consumer.user_update/0","type":"type","doc":"Dispatched when a user is updated. old_user will be nil when the pre-update user could not be fetched from the cache."},{"ref":"Nostrum.Consumer.html#t:voice_server_update/0","title":"Nostrum.Consumer.voice_server_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:voice_state_update/0","title":"Nostrum.Consumer.voice_state_update/0","type":"type","doc":""},{"ref":"Nostrum.Consumer.html#t:webhooks_update/0","title":"Nostrum.Consumer.webhooks_update/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html","title":"Nostrum.Error.ApiError","type":"exception","doc":"Represents a failed response from the API. This occurs when hackney or HTTPoison fail, or when the API doesn&#39;t respond with 200 or 204. This should only occur when using the banged API methods."},{"ref":"Nostrum.Error.ApiError.html#t:detailed_error/0","title":"Nostrum.Error.ApiError.detailed_error/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:discord_status_code/0","title":"Nostrum.Error.ApiError.discord_status_code/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:error/0","title":"Nostrum.Error.ApiError.error/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:error_list_map/0","title":"Nostrum.Error.ApiError.error_list_map/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:errors/0","title":"Nostrum.Error.ApiError.errors/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:response/0","title":"Nostrum.Error.ApiError.response/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:status_code/0","title":"Nostrum.Error.ApiError.status_code/0","type":"type","doc":""},{"ref":"Nostrum.Error.ApiError.html#t:t/0","title":"Nostrum.Error.ApiError.t/0","type":"type","doc":""},{"ref":"Nostrum.Error.CacheError.html","title":"Nostrum.Error.CacheError","type":"exception","doc":"Represents an error when interacting with the cache. This likely occurs because a specified item could not be found in the cache, or your were searching for something invalid. This should only occur when using the banged cache methods."},{"ref":"Nostrum.Permission.html","title":"Nostrum.Permission","type":"module","doc":"Functions that work on permissions. Some functions return a list of permissions. You can use enumerable functions to work with permissions: alias Nostrum.Cache.GuildCache alias Nostrum.Struct.Guild.Member guild = GuildCache.get!(279093381723062272) member = Map.get(guild.members, 177888205536886784) member_perms = Member.guild_permissions(member, guild) if :administrator in member_perms do IO.puts(&quot;This user has the administrator permission.&quot;) end"},{"ref":"Nostrum.Permission.html#all/0","title":"Nostrum.Permission.all/0","type":"function","doc":"Returns a list of all permissions."},{"ref":"Nostrum.Permission.html#from_bit/1","title":"Nostrum.Permission.from_bit/1","type":"function","doc":"Converts the given bit to a permission. This function returns :error if bit does not map to a permission. Examples iex&gt; Nostrum.Permission.from_bit(0x04000000) {:ok, :change_nickname} iex&gt; Nostrum.Permission.from_bit(0) :error"},{"ref":"Nostrum.Permission.html#from_bit!/1","title":"Nostrum.Permission.from_bit!/1","type":"function","doc":"Same as from_bit/1, but raises ArgumentError in case of failure. Examples iex&gt; Nostrum.Permission.from_bit!(0x04000000) :change_nickname iex&gt; Nostrum.Permission.from_bit!(0) ** (ArgumentError) expected a valid bit, got: `0`"},{"ref":"Nostrum.Permission.html#from_bitset/1","title":"Nostrum.Permission.from_bitset/1","type":"function","doc":"Converts the given bitset to a list of permissions. If invalid bits are given they will be omitted from the results. Examples iex&gt; Nostrum.Permission.from_bitset(0x08000002) [:manage_nicknames, :kick_members] iex&gt; Nostrum.Permission.from_bitset(0x4000000000000) []"},{"ref":"Nostrum.Permission.html#is_permission/1","title":"Nostrum.Permission.is_permission/1","type":"macro","doc":"Returns true if term is a permission; otherwise returns false. Examples iex&gt; Nostrum.Permission.is_permission(:administrator) true iex&gt; Nostrum.Permission.is_permission(:not_a_permission) false"},{"ref":"Nostrum.Permission.html#to_bit/1","title":"Nostrum.Permission.to_bit/1","type":"function","doc":"Converts the given permission to a bit. Examples iex&gt; Nostrum.Permission.to_bit(:administrator) 8"},{"ref":"Nostrum.Permission.html#to_bitset/1","title":"Nostrum.Permission.to_bitset/1","type":"function","doc":"Converts the given enumerable of permissions to a bitset. Examples iex&gt; Nostrum.Permission.to_bitset([:administrator, :create_instant_invite]) 9"},{"ref":"Nostrum.Permission.html#t:bit/0","title":"Nostrum.Permission.bit/0","type":"type","doc":"Represents a single permission as a bitvalue."},{"ref":"Nostrum.Permission.html#t:bitset/0","title":"Nostrum.Permission.bitset/0","type":"type","doc":"Represents a set of permissions as a bitvalue."},{"ref":"Nostrum.Permission.html#t:general_permission/0","title":"Nostrum.Permission.general_permission/0","type":"type","doc":""},{"ref":"Nostrum.Permission.html#t:t/0","title":"Nostrum.Permission.t/0","type":"type","doc":""},{"ref":"Nostrum.Permission.html#t:text_permission/0","title":"Nostrum.Permission.text_permission/0","type":"type","doc":""},{"ref":"Nostrum.Permission.html#t:voice_permission/0","title":"Nostrum.Permission.voice_permission/0","type":"type","doc":""},{"ref":"Nostrum.Snowflake.html","title":"Nostrum.Snowflake","type":"module","doc":"Functions that work on Snowflakes."},{"ref":"Nostrum.Snowflake.html#cast/1","title":"Nostrum.Snowflake.cast/1","type":"function","doc":"Attempts to convert a term into a snowflake. Examples iex&gt; Nostrum.Snowflake.cast(200317799350927360) {:ok, 200317799350927360} iex&gt; Nostrum.Snowflake.cast(&quot;200317799350927360&quot;) {:ok, 200317799350927360} iex&gt; Nostrum.Snowflake.cast(nil) {:ok, nil} iex&gt; Nostrum.Snowflake.cast(true) :error iex&gt; Nostrum.Snowflake.cast(-1) :error"},{"ref":"Nostrum.Snowflake.html#cast!/1","title":"Nostrum.Snowflake.cast!/1","type":"function","doc":"Same as cast/1, except it raises an ArgumentError on failure."},{"ref":"Nostrum.Snowflake.html#creation_time/1","title":"Nostrum.Snowflake.creation_time/1","type":"function","doc":"Returns the creation time of the snowflake. Examples iex&gt; Nostrum.Snowflake.creation_time(177888205536886784) ~U[2016-05-05 21:04:13.203Z]"},{"ref":"Nostrum.Snowflake.html#dump/1","title":"Nostrum.Snowflake.dump/1","type":"function","doc":"Convert a snowflake into its external representation. Examples iex&gt; Nostrum.Snowflake.dump(109112383011581952) &quot;109112383011581952&quot;"},{"ref":"Nostrum.Snowflake.html#from_datetime/1","title":"Nostrum.Snowflake.from_datetime/1","type":"function","doc":"Converts the given datetime into a snowflake. If datetime occured before the discord epoch, the function will return :error. The converted snowflake&#39;s last 22 bits will be zeroed out due to missing data. Examples iex&gt; {:ok, dt, _} = DateTime.from_iso8601(&quot;2016-05-05T21:04:13.203Z&quot;) iex&gt; Nostrum.Snowflake.from_datetime(dt) {:ok, 177888205536755712} iex&gt; {:ok, dt, _} = DateTime.from_iso8601(&quot;1998-12-25T00:00:00.000Z&quot;) iex&gt; Nostrum.Snowflake.from_datetime(dt) :error"},{"ref":"Nostrum.Snowflake.html#from_datetime!/1","title":"Nostrum.Snowflake.from_datetime!/1","type":"function","doc":"Same as from_datetime/1, except it raises an ArgumentError on failure."},{"ref":"Nostrum.Snowflake.html#is_snowflake/1","title":"Nostrum.Snowflake.is_snowflake/1","type":"macro","doc":"Returns true if term is a snowflake; otherwise returns false. Examples iex&gt; Nostrum.Snowflake.is_snowflake(89918932789497856) true iex&gt; Nostrum.Snowflake.is_snowflake(-1) false iex&gt; Nostrum.Snowflake.is_snowflake(0xFFFFFFFFFFFFFFFF + 1) false iex&gt; Nostrum.Snowflake.is_snowflake(&quot;117789813427535878&quot;) false"},{"ref":"Nostrum.Snowflake.html#t:external_snowflake/0","title":"Nostrum.Snowflake.external_snowflake/0","type":"type","doc":"The type that represents snowflakes in JSON. In JSON, Snowflakes are typically represented as strings due to some languages not being able to represent such a large number."},{"ref":"Nostrum.Snowflake.html#t:t/0","title":"Nostrum.Snowflake.t/0","type":"type","doc":"The snowflake type. Snowflakes are 64-bit unsigned integers used to represent discord object ids."},{"ref":"Nostrum.Util.html","title":"Nostrum.Util","type":"module","doc":"Utility functions"},{"ref":"Nostrum.Util.html#enum_to_struct/2","title":"Nostrum.Util.enum_to_struct/2","type":"function","doc":""},{"ref":"Nostrum.Util.html#gateway/0","title":"Nostrum.Util.gateway/0","type":"function","doc":"Returns the gateway url and shard count for current websocket connections. If by chance no gateway connection has been made, will fetch the url to use and store it for future use."},{"ref":"Nostrum.Util.html#maybe_to_atom/1","title":"Nostrum.Util.maybe_to_atom/1","type":"function","doc":"Attempts to convert a string to an atom. If atom does not currently exist, will warn that we&#39;re doing an unsafe conversion."},{"ref":"Nostrum.Util.html#nostrum_struct/1","title":"Nostrum.Util.nostrum_struct/1","type":"macro","doc":"Helper for defining all the methods used for struct and encoding transformations. Example Nostrum.Util.nostrum_struct(%{ author: User, mentions: [User], mention_roles: [User], embeds: [Embed] })"},{"ref":"Nostrum.Util.html#now/0","title":"Nostrum.Util.now/0","type":"function","doc":"Returns the number of milliseconds since unix epoch."},{"ref":"Nostrum.Util.html#now_iso/0","title":"Nostrum.Util.now_iso/0","type":"function","doc":"Returns the current date as an ISO formatted string."},{"ref":"Nostrum.Util.html#num_shards/0","title":"Nostrum.Util.num_shards/0","type":"function","doc":"Returns the number of shards. This is not the number of currently active shards, but the number of shards specified in your config."},{"ref":"Nostrum.Util.html#safe_atom_map/1","title":"Nostrum.Util.safe_atom_map/1","type":"function","doc":"Converts a map into an atom-keyed map. Given a map with variable type keys, returns the same map with all keys as atoms. This function will attempt to convert keys to an existing atom, and if that fails will default to creating a new atom while displaying a warning. The idea here is that we should be able to see if any results from Discord are giving variable keys. Since we will define all types of objects returned by Discord, the amount of new atoms created SHOULD be 0. 👀"},{"ref":"Nostrum.Util.html#unused_atoms/0","title":"Nostrum.Util.unused_atoms/0","type":"function","doc":"Since we&#39;re being sacrilegious and converting strings to atoms from the WS, there will be some atoms that we see that aren&#39;t defined in any Discord structs. This method mainly serves as a means to define those atoms once so the user isn&#39;t warned about them in the Nostrum.Util.maybe_to_atom/1 function when they are in fact harmless."},{"ref":"Nostrum.Api.html","title":"Nostrum.Api","type":"module","doc":"Interface for Discord&#39;s rest API. By default all methods in this module are ran synchronously. If you wish to have async rest operations I recommend you execute these functions inside of a task. Examples # Async Task t = Task.async fn -&gt; Nostrum.Api.get_channel_messages(12345678912345, :infinity, {}) end messages = Task.await t # A lot of times we don&#39;t care about the return value of the function Task.start fn -&gt; messages = [&quot;in&quot;, &quot;the&quot;, &quot;end&quot;, &quot;it&quot;, &quot;doesn&#39;t&quot;, &quot;even&quot;, &quot;matter&quot;] Enum.each messages, &amp;Nostrum.Api.create_message!(12345678912345, &amp;1) end A note about Strings and Ints Currently, responses from the REST api will have id fields as string. Everything received from the WS connection will have id fields as int. If you&#39;re processing a response from the API and trying to access something in the cache based off of an id in the response, you will need to conver it to an int using String.to_integer/1. I&#39;m open to suggestions for how this should be handled going forward. Example messages = Nostrum.Api.get_pinned_messages!(12345678912345) authors = Enum.map messages, fn msg -&gt; author_id = String.to_integer(msg.author.id) Nostrum.Cache.User.get!(id: author_id) end"},{"ref":"Nostrum.Api.html#add_guild_member/3","title":"Nostrum.Api.add_guild_member/3","type":"function","doc":"Puts a user in a guild. This endpoint fires the Nostrum.Consumer.guild_member_add/0 event. It requires the CREATE_INSTANT_INVITE permission. Additionally, it situationally requires the MANAGE_NICKNAMES, MANAGE_ROLES, MUTE_MEMBERS, and DEAFEN_MEMBERS permissions. If successful, returns {:ok, member} or {:ok} if the user was already a member of the guild. Otherwise, returns a Nostrum.Api.error/0. Options :access_token (string) - the user&#39;s oauth2 access token :nick (string) - value to set users nickname to :roles (list of Nostrum.Struct.Guild.Role.id/0) - array of role ids the member is assigned :mute (boolean) - if the user is muted :deaf (boolean) - if the user is deafened :access_token is always required. Examples Nostrum.Api.add_guild_member( 41771983423143937, 18374719829378473, access_token: &quot;6qrZcUqja7812RVdnEKjpzOL4CvHBFG&quot;, nick: &quot;nostrum&quot;, roles: [431849301, 913809431] )"},{"ref":"Nostrum.Api.html#add_guild_member!/3","title":"Nostrum.Api.add_guild_member!/3","type":"function","doc":"Same as add_guild_member/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#add_guild_member_role/4","title":"Nostrum.Api.add_guild_member_role/4","type":"function","doc":"Adds a role to a member. Role to add is specified by role_id. User to add role to is specified by guild_id and user_id. An optional reason can be given for the audit log."},{"ref":"Nostrum.Api.html#add_pinned_channel_message/2","title":"Nostrum.Api.add_pinned_channel_message/2","type":"function","doc":"Pins a message in a channel. This endpoint requires the &#39;VIEW_CHANNEL&#39;, &#39;READ_MESSAGE_HISTORY&#39;, and &#39;MANAGE_MESSAGES&#39; permissions. It fires the Nostrum.Consumer.message_update/0 and Nostrum.Consumer.channel_pins_update/0 events. If successful, returns {:ok}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.add_pinned_channel_message(43189401384091, 18743893102394)"},{"ref":"Nostrum.Api.html#add_pinned_channel_message!/2","title":"Nostrum.Api.add_pinned_channel_message!/2","type":"function","doc":"Same as add_pinned_channel_message/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#begin_guild_prune/3","title":"Nostrum.Api.begin_guild_prune/3","type":"function","doc":"Begins a guild prune to prune members within days. An optional reason can be provided for the guild audit log. This endpoint requires the KICK_MEMBERS permission. It fires multiple Nostrum.Consumer.guild_member_remove/0 events. If successful, returns {:ok, %{pruned: pruned}}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.begin_guild_prune(81384788765712384, 1) {:ok, %{pruned: 0}}"},{"ref":"Nostrum.Api.html#begin_guild_prune!/3","title":"Nostrum.Api.begin_guild_prune!/3","type":"function","doc":"Same as begin_guild_prune/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#bulk_delete_messages/3","title":"Nostrum.Api.bulk_delete_messages/3","type":"function","doc":"Deletes multiple messages from a channel. messages is a list of Nostrum.Struct.Message.id that you wish to delete. When given more than 100 messages, this function will chunk the given message list into blocks of 100 and send them off to the API. It will stop deleting on the first error that occurs. Keep in mind that deleting thousands of messages will take a pretty long time and it may be proper to just delete the channel you want to bulk delete in and recreate it. This method can only delete messages sent within the last two weeks. Filter is an optional parameter that specifies whether messages sent over two weeks ago should be filtered out; defaults to true."},{"ref":"Nostrum.Api.html#bulk_delete_messages!/3","title":"Nostrum.Api.bulk_delete_messages!/3","type":"function","doc":"Same as bulk_delete_messages/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_channel_invite/3","title":"Nostrum.Api.create_channel_invite/3","type":"function","doc":"Creates an invite for a guild channel. An optional reason can be provided for the audit log. This endpoint requires the CREATE_INSTANT_INVITE permission. If successful, returns {:ok, invite}. Otherwise, returns a Nostrum.Api.error/0. Options :max_age (integer) - duration of invite in seconds before expiry, or 0 for never. (default: 86400) :max_uses (integer) - max number of uses or 0 for unlimited. (default: 0) :temporary (boolean) - Whether the invite should grant temporary membership. (default: false) :unique (boolean) - used when creating unique one time use invites. (default: false) Examples Nostrum.Api.create_channel_invite(41771983423143933) {:ok, Nostrum.Struct.Invite{}} Nostrum.Api.create_channel_invite(41771983423143933, max_uses: 20) {:ok, %Nostrum.Struct.Invite{}}"},{"ref":"Nostrum.Api.html#create_channel_invite!/3","title":"Nostrum.Api.create_channel_invite!/3","type":"function","doc":"Same as create_channel_invite/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_dm/1","title":"Nostrum.Api.create_dm/1","type":"function","doc":"Create a new DM channel with a user. If successful, returns {:ok, dm_channel}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.create_dm(150061853001777154) {:ok, %Nostrum.Struct.Channel{type: 1}}"},{"ref":"Nostrum.Api.html#create_dm!/1","title":"Nostrum.Api.create_dm!/1","type":"function","doc":"Same as create_dm/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_group_dm/2","title":"Nostrum.Api.create_group_dm/2","type":"function","doc":"Creates a new group DM channel. If successful, returns {:ok, group_dm_channel}. Otherwise, returns a Nostrum.Api.error/0. access_tokens are user oauth2 tokens. nicks is a map that maps a user id to a nickname. Examples Nostrum.Api.create_group_dm([&quot;6qrZcUqja7812RVdnEKjpzOL4CvHBFG&quot;], %{41771983423143937 =&gt; &quot;My Nickname&quot;}) {:ok, %Nostrum.Struct.Channel{type: 3}}"},{"ref":"Nostrum.Api.html#create_group_dm!/2","title":"Nostrum.Api.create_group_dm!/2","type":"function","doc":"Same as create_group_dm/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_guild_ban/4","title":"Nostrum.Api.create_guild_ban/4","type":"function","doc":"Bans a user from a guild. User to delete is specified by guild_id and user_id. An optional reason can be specified for the audit log."},{"ref":"Nostrum.Api.html#create_guild_channel/2","title":"Nostrum.Api.create_guild_channel/2","type":"function","doc":"Creates a channel for a guild. This endpoint requires the MANAGE_CHANNELS permission. It fires a Nostrum.Consumer.channel_create/0 event. If successful, returns {:ok, channel}. Otherwise, returns a Nostrum.Api.error/0. Options :name (string) - channel name (2-100 characters) :type (integer) - the type of channel (See Nostrum.Struct.Channel) :topic (string) - channel topic (0-1024 characters) :bitrate (integer) - the bitrate (in bits) of the voice channel (voice only) :user_limit (integer) - the user limit of the voice channel (voice only) :permission_overwrites (list of Nostrum.Struct.Overwrite.t/0 or equivalent map) - the channel&#39;s permission overwrites :parent_id (Nostrum.Struct.Channel.id/0) - id of the parent category for a channel :nsfw (boolean) - if the channel is nsfw :name is always required. Examples Nostrum.Api.create_guild_channel(81384788765712384, name: &quot;elixir-nostrum&quot;, topic: &quot;craig&#39;s domain&quot;) {:ok, %Nostrum.Struct.Channel{guild_id: 81384788765712384}}"},{"ref":"Nostrum.Api.html#create_guild_channel!/2","title":"Nostrum.Api.create_guild_channel!/2","type":"function","doc":"Same as create_guild_channel/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_guild_emoji/3","title":"Nostrum.Api.create_guild_emoji/3","type":"function","doc":"Creates a new emoji for the given guild. This endpoint requires the MANAGE_EMOJIS permission. It fires a Nostrum.Consumer.guild_emojis_update/0 event. An optional reason can be provided for the audit log. If successful, returns {:ok, emoji}. Otherwise, returns Nostrum.Api.error/0. Options :name (string) - name of the emoji :image (base64 data URI) - the 128x128 emoji image. Maximum size of 256kb :roles (list of Nostrum.Snowflake.t/0) - roles for which this emoji will be whitelisted (default: []) :name and :image are always required. Examples image = &quot;data:image/png;base64,YXl5IGJieSB1IGx1a2luIDQgc3VtIGZ1az8=&quot; Nostrum.Api.create_guild_emoji(43189401384091, name: &quot;nostrum&quot;, image: image, roles: [])"},{"ref":"Nostrum.Api.html#create_guild_emoji!/3","title":"Nostrum.Api.create_guild_emoji!/3","type":"function","doc":"Same as create_guild_emoji/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_guild_integrations/2","title":"Nostrum.Api.create_guild_integrations/2","type":"function","doc":"Creates a new guild integeration. Guild to create integration with is specified by guild_id. options is a map with the following requires keys: type - Integration type. id - Integeration id."},{"ref":"Nostrum.Api.html#create_guild_role/3","title":"Nostrum.Api.create_guild_role/3","type":"function","doc":"Creates a guild role. An optional reason for the audit log can be provided via reason. This endpoint requires the MANAGE_ROLES permission. It fires a Nostrum.Consumer.guild_role_create/0 event. If successful, returns {:ok, role}. Otherwise, returns a Nostrum.Api.error/0. Options :name (string) - name of the role (default: &quot;new role&quot;) :permissions (integer) - bitwise of the enabled/disabled permissions (default: @everyone perms) :color (integer) - RGB color value (default: 0) :hoist (boolean) - whether the role should be displayed separately in the sidebar (default: false) :mentionable (boolean) - whether the role should be mentionable (default: false) Examples Nostrum.Api.create_guild_role(41771983423143937, name: &quot;nostrum-club&quot;, hoist: true)"},{"ref":"Nostrum.Api.html#create_guild_role!/3","title":"Nostrum.Api.create_guild_role!/3","type":"function","doc":"Same as create_guild_role/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_message/2","title":"Nostrum.Api.create_message/2","type":"function","doc":"Posts a message to a guild text or DM channel. This endpoint requires the VIEW_CHANNEL and SEND_MESSAGES permissions. It may situationally need the SEND_MESSAGES_TTS permission. It fires the Nostrum.Consumer.message_create/0 event. If options is a string, options will be used as the message&#39;s content. If successful, returns {:ok, message}. Otherwise, returns a Nostrum.Api.error/0. Options :content (string) - the message contents (up to 2000 characters) :nonce (Nostrum.Snowflake.t/0) - a nonce that can be used for optimistic message sending :tts (boolean) - true if this is a TTS message :file (Path.t/0 | map) - the path of the file being sent, or a map with the following keys if sending a binary from memory :name (string) - the name of the file :body (string) - binary you wish to send :embed (Nostrum.Struct.Embed.t/0) - embedded rich content At least one of the following is required: :content, :file, :embed. Examples Nostrum.Api.create_message(43189401384091, content: &quot;hello world!&quot;) Nostrum.Api.create_message(43189401384091, &quot;hello world!&quot;) import Nostrum.Struct.Embed embed = %Nostrum.Struct.Embed{} |&gt; put_title(&quot;embed&quot;) |&gt; put_description(&quot;new desc&quot;) Nostrum.Api.create_message(43189401384091, embed: embed) Nostrum.Api.create_message(43189401384091, file: &quot;/path/to/file.txt&quot;) Nostrum.Api.create_message(43189401384091, content: &quot;hello world!&quot;, embed: embed, file: &quot;/path/to/file.txt&quot;)"},{"ref":"Nostrum.Api.html#create_message!/2","title":"Nostrum.Api.create_message!/2","type":"function","doc":"Same as create_message/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_reaction/3","title":"Nostrum.Api.create_reaction/3","type":"function","doc":"Creates a reaction for a message. This endpoint requires the VIEW_CHANNEL and READ_MESSAGE_HISTORY permissions. Additionally, if nobody else has reacted to the message with the emoji, this endpoint requires the ADD_REACTIONS permission. It fires a Nostrum.Consumer.message_reaction_add/0 event. If successful, returns {:ok}. Otherwise, returns Nostrum.Api.error/0. Examples # Using a Nostrum.Struct.Emoji. emoji = %Nostrum.Struct.Emoji{id: 43819043108, name: &quot;foxbot&quot;} Nostrum.Api.create_reaction(123123123123, 321321321321, emoji) # Using a base 16 emoji string. Nostrum.Api.create_reaction(123123123123, 321321321321, &quot;\\xF0\\x9F\\x98\\x81&quot;) For other emoji string examples, see Nostrum.Struct.Emoji.api_name/0."},{"ref":"Nostrum.Api.html#create_reaction!/3","title":"Nostrum.Api.create_reaction!/3","type":"function","doc":"Same as create_reaction/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#create_webhook/3","title":"Nostrum.Api.create_webhook/3","type":"function","doc":"Creates a webhook. Parameters channel_id - Id of the channel to send the message to. args - Map with the following required keys: name - Name of the webhook. avatar - Base64 128x128 jpeg image for the default avatar. reason - An optional reason for the guild audit log."},{"ref":"Nostrum.Api.html#delete_all_reactions/2","title":"Nostrum.Api.delete_all_reactions/2","type":"function","doc":"Deletes all reactions from a message. This endpoint requires the VIEW_CHANNEL, READ_MESSAGE_HISTORY, and MANAGE_MESSAGES permissions. It fires a Nostrum.Consumer.message_reaction_remove_all/0 event. If successful, returns {:ok}. Otherwise, return Nostrum.Api.error/0."},{"ref":"Nostrum.Api.html#delete_all_reactions!/2","title":"Nostrum.Api.delete_all_reactions!/2","type":"function","doc":"Same as delete_all_reactions/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_channel/2","title":"Nostrum.Api.delete_channel/2","type":"function","doc":"Deletes a channel. An optional reason can be provided for the guild audit log. If deleting a Nostrum.Struct.Channel.guild_channel/0, this endpoint requires the MANAGE_CHANNELS permission. It fires a Nostrum.Consumer.channel_delete/0. If a Nostrum.Struct.Channel.channel_category/0 is deleted, then a Nostrum.Consumer.channel_update/0 event will fire for each channel under the category. If successful, returns {:ok, channel}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.delete_channel(421533712753360896) {:ok, %Nostrum.Struct.Channel{id: 421533712753360896}}"},{"ref":"Nostrum.Api.html#delete_channel!/2","title":"Nostrum.Api.delete_channel!/2","type":"function","doc":"Same as delete_channel/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_channel_permissions/3","title":"Nostrum.Api.delete_channel_permissions/3","type":"function","doc":"Delete a channel permission for a user or role. Role or user overwrite to delete is specified by channel_id and overwrite_id. An optional reason can be given for the audit log."},{"ref":"Nostrum.Api.html#delete_guild/1","title":"Nostrum.Api.delete_guild/1","type":"function","doc":"Deletes a guild. This endpoint requires that the current user is the owner of the guild. It fires the Nostrum.Consumer.guild_delete/0 event. If successful, returns {:ok}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.delete_guild(81384788765712384) {:ok}"},{"ref":"Nostrum.Api.html#delete_guild!/1","title":"Nostrum.Api.delete_guild!/1","type":"function","doc":"Same as delete_guild/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_guild_emoji/3","title":"Nostrum.Api.delete_guild_emoji/3","type":"function","doc":"Deletes the given emoji. An optional reason can be provided for the audit log. This endpoint requires the MANAGE_EMOJIS permission. It fires a Nostrum.Consumer.guild_emojis_update/0 event. If successful, returns {:ok}. Otherwise, returns Nostrum.Api.error/0."},{"ref":"Nostrum.Api.html#delete_guild_emoji!/3","title":"Nostrum.Api.delete_guild_emoji!/3","type":"function","doc":"Same as delete_guild_emoji/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_guild_integrations/2","title":"Nostrum.Api.delete_guild_integrations/2","type":"function","doc":"Deletes a guild integeration. Integration to delete is specified by guild_id and integeration_id."},{"ref":"Nostrum.Api.html#delete_guild_role/3","title":"Nostrum.Api.delete_guild_role/3","type":"function","doc":"Deletes a role from a guild. An optional reason can be specified for the audit log. This endpoint requires the MANAGE_ROLES permission. It fires a Nostrum.Consumer.guild_role_delete/0 event. If successful, returns {:ok}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.delete_guild_role(41771983423143937, 392817238471936)"},{"ref":"Nostrum.Api.html#delete_guild_role!/3","title":"Nostrum.Api.delete_guild_role!/3","type":"function","doc":"Same as delete_guild_role/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_invite/1","title":"Nostrum.Api.delete_invite/1","type":"function","doc":"Deletes an invite by its invite_code. This endpoint requires the MANAGE_CHANNELS permission. If successful, returns {:ok, invite}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.delete_invite(&quot;zsjUsC&quot;) {:ok, %Nostrum.Struct.Invite{code: &quot;zsjUsC&quot;}}"},{"ref":"Nostrum.Api.html#delete_invite!/1","title":"Nostrum.Api.delete_invite!/1","type":"function","doc":"Same as delete_invite/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_message/1","title":"Nostrum.Api.delete_message/1","type":"function","doc":"Same as delete_message/2, but takes a Nostrum.Struct.Message instead of a channel_id and message_id."},{"ref":"Nostrum.Api.html#delete_message/2","title":"Nostrum.Api.delete_message/2","type":"function","doc":"Deletes a message. This endpoint requires the &#39;VIEW_CHANNEL&#39; and &#39;MANAGE_MESSAGES&#39; permission. It fires the MESSAGE_DELETE event. If successful, returns {:ok}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.delete_message(43189401384091, 43189401384091)"},{"ref":"Nostrum.Api.html#delete_message!/1","title":"Nostrum.Api.delete_message!/1","type":"function","doc":"Same as delete_message/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_message!/2","title":"Nostrum.Api.delete_message!/2","type":"function","doc":"Same as delete_message/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_own_reaction/3","title":"Nostrum.Api.delete_own_reaction/3","type":"function","doc":"Deletes a reaction the current user has made for the message. This endpoint requires the VIEW_CHANNEL and READ_MESSAGE_HISTORY permissions. It fires a Nostrum.Consumer.message_reaction_remove/0 event. If successful, returns {:ok}. Otherwise, returns Nostrum.Api.error/0. See create_reaction/3 for similar examples."},{"ref":"Nostrum.Api.html#delete_own_reaction!/3","title":"Nostrum.Api.delete_own_reaction!/3","type":"function","doc":"Same as delete_own_reaction/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_pinned_channel_message/2","title":"Nostrum.Api.delete_pinned_channel_message/2","type":"function","doc":"Unpins a message in a channel. This endpoint requires the &#39;VIEW_CHANNEL&#39;, &#39;READ_MESSAGE_HISTORY&#39;, and &#39;MANAGE_MESSAGES&#39; permissions. It fires the Nostrum.Consumer.message_update/0 and Nostrum.Consumer.channel_pins_update/0 events. Returns {:ok} if successful. error otherwise."},{"ref":"Nostrum.Api.html#delete_pinned_channel_message!/2","title":"Nostrum.Api.delete_pinned_channel_message!/2","type":"function","doc":"Same as delete_pinned_channel_message/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_user_reaction/4","title":"Nostrum.Api.delete_user_reaction/4","type":"function","doc":"Deletes another user&#39;s reaction from a message. This endpoint requires the VIEW_CHANNEL, READ_MESSAGE_HISTORY, and MANAGE_MESSAGES permissions. It fires a Nostrum.Consumer.message_reaction_remove/0 event. If successful, returns {:ok}. Otherwise, returns Nostrum.Api.error/0. See create_reaction/3 for similar examples."},{"ref":"Nostrum.Api.html#delete_user_reaction!/4","title":"Nostrum.Api.delete_user_reaction!/4","type":"function","doc":"Same as delete_user_reaction/4, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#delete_webhook/2","title":"Nostrum.Api.delete_webhook/2","type":"function","doc":"Deletes a webhook. Parameters webhook_id - Id of webhook to delete. reason - An optional reason for the guild audit log."},{"ref":"Nostrum.Api.html#edit_channel_permissions/4","title":"Nostrum.Api.edit_channel_permissions/4","type":"function","doc":"Edit the permission overwrites for a user or role. Role or user to overwrite is specified by overwrite_id. permission_info is a map with the following keys: type - Required; member if editing a user, role if editing a role. allow - Bitwise value of allowed permissions. deny - Bitwise value of denied permissions. type - member if editing a user, role if editing a role. An optional reason can be provided for the audit log. allow and deny are defaulted to 0, meaning that even if you don&#39;t specify them, they will override their respective former values in an existing overwrite."},{"ref":"Nostrum.Api.html#edit_channel_permissions!/4","title":"Nostrum.Api.edit_channel_permissions!/4","type":"function","doc":"Same as edit_channel_permissions/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#edit_message/2","title":"Nostrum.Api.edit_message/2","type":"function","doc":"Same as edit_message/3, but takes a Nostrum.Struct.Message instead of a channel_id and message_id."},{"ref":"Nostrum.Api.html#edit_message/3","title":"Nostrum.Api.edit_message/3","type":"function","doc":"Edits a previously sent message in a channel. This endpoint requires the VIEW_CHANNEL permission. It fires the Nostrum.Consumer.message_update/0 event. If options is a string, options will be used as the message&#39;s content. If successful, returns {:ok, message}. Otherwise, returns a Nostrum.Api.error/0. Options :content (string) - the message contents (up to 2000 characters) :embed (Nostrum.Struct.Embed.t/0) - embedded rich content Examples Nostrum.Api.edit_message(43189401384091, 1894013840914098, content: &quot;hello world!&quot;) Nostrum.Api.edit_message(43189401384091, 1894013840914098, &quot;hello world!&quot;) import Nostrum.Struct.Embed embed = %Nostrum.Struct.Embed{} |&gt; put_title(&quot;embed&quot;) |&gt; put_description(&quot;new desc&quot;) Nostrum.Api.edit_message(43189401384091, 1894013840914098, embed: embed) Nostrum.Api.edit_message(43189401384091, 1894013840914098, content: &quot;hello world!&quot;, embed: embed)"},{"ref":"Nostrum.Api.html#edit_message!/2","title":"Nostrum.Api.edit_message!/2","type":"function","doc":"Same as edit_message/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#edit_message!/3","title":"Nostrum.Api.edit_message!/3","type":"function","doc":"Same as edit_message/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#execute_git_webhook/3","title":"Nostrum.Api.execute_git_webhook/3","type":"function","doc":"Executes a git webhook. Parameters webhook_id - Id of the webhook to execute. webhook_token - Token of the webhook to execute."},{"ref":"Nostrum.Api.html#execute_slack_webhook/3","title":"Nostrum.Api.execute_slack_webhook/3","type":"function","doc":"Executes a slack webhook. Parameters webhook_id - Id of the webhook to execute. webhook_token - Token of the webhook to execute."},{"ref":"Nostrum.Api.html#execute_webhook/4","title":"Nostrum.Api.execute_webhook/4","type":"function","doc":"Executes a webhook. Parameters webhook_id - Id of the webhook to execute. webhook_token - Token of the webhook to execute. args - Map with the following required keys: content - Message content. file - File to send. embeds - List of embeds to send. username - Overrides the default name of the webhook. avatar_url - Overrides the default avatar of the webhook. tts - Whether the message should be read over text to speech. wait - Whether to return an error or not. Defaults to false. Only one of content, file or embeds should be supplied in the args parameter."},{"ref":"Nostrum.Api.html#get_application_information/0","title":"Nostrum.Api.get_application_information/0","type":"function","doc":"Gets the bot&#39;s OAuth2 application info. Example Nostrum.Api.get_application_information {:ok, %{ bot_public: false, bot_require_code_grant: false, description: &quot;Test&quot;, icon: nil, id: &quot;172150183260323840&quot;, name: &quot;Baba O-Riley&quot;, owner: %{ avatar: nil, discriminator: &quot;0042&quot;, id: &quot;172150183260323840&quot;, username: &quot;i own a bot&quot; }, }}"},{"ref":"Nostrum.Api.html#get_channel/1","title":"Nostrum.Api.get_channel/1","type":"function","doc":"Gets a channel. If successful, returns {:ok, channel}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_channel(381889573426429952) {:ok, %Nostrum.Struct.Channel{id: 381889573426429952}}"},{"ref":"Nostrum.Api.html#get_channel!/1","title":"Nostrum.Api.get_channel!/1","type":"function","doc":"Same as get_channel/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_channel_invites/1","title":"Nostrum.Api.get_channel_invites/1","type":"function","doc":"Gets a list of invites for a channel. This endpoint requires the &#39;VIEW_CHANNEL&#39; and &#39;MANAGE_CHANNELS&#39; permissions. If successful, returns {:ok, invite}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_channel_invites(43189401384091) {:ok, [%Nostrum.Struct.Invite{} | _]}"},{"ref":"Nostrum.Api.html#get_channel_invites!/1","title":"Nostrum.Api.get_channel_invites!/1","type":"function","doc":"Same as get_channel_invites/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_channel_message/2","title":"Nostrum.Api.get_channel_message/2","type":"function","doc":"Retrieves a message from a channel. This endpoint requires the &#39;VIEW_CHANNEL&#39; and &#39;READ_MESSAGE_HISTORY&#39; permissions. If successful, returns {:ok, message}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_channel_message(43189401384091, 198238475613443)"},{"ref":"Nostrum.Api.html#get_channel_message!/2","title":"Nostrum.Api.get_channel_message!/2","type":"function","doc":"Same as get_channel_message/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_channel_messages/3","title":"Nostrum.Api.get_channel_messages/3","type":"function","doc":"Retrieves a channel&#39;s messages around a locator up to a limit. This endpoint requires the &#39;VIEW_CHANNEL&#39; permission. If the current user is missing the &#39;READ_MESSAGE_HISTORY&#39; permission, then this function will return no messages. If successful, returns {:ok, messages}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_channel_messages(43189401384091, 5, {:before, 130230401384})"},{"ref":"Nostrum.Api.html#get_channel_messages!/3","title":"Nostrum.Api.get_channel_messages!/3","type":"function","doc":"Same as get_channel_messages/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_channel_webhooks/1","title":"Nostrum.Api.get_channel_webhooks/1","type":"function","doc":"Gets a list of webook for a channel. Parameters channel_id - Channel to get webhooks for."},{"ref":"Nostrum.Api.html#get_current_user/0","title":"Nostrum.Api.get_current_user/0","type":"function","doc":"Gets info on the current user. If nostrum&#39;s caching is enabled, it is recommended to use Nostrum.Cache.Me.get/0 instead of this function. This is because sending out an API request is much slower than pulling from our cache. If the request is successful, this function returns {:ok, user}, where user is nostrum&#39;s Nostrum.Struct.User. Otherwise, returns {:error, reason}."},{"ref":"Nostrum.Api.html#get_current_user!/0","title":"Nostrum.Api.get_current_user!/0","type":"function","doc":"Same as get_current_user/0, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_current_user_guilds/1","title":"Nostrum.Api.get_current_user_guilds/1","type":"function","doc":"Gets a list of guilds the user is currently in. This endpoint requires the guilds OAuth2 scope. If successful, returns {:ok, guilds}. Otherwise, returns a Nostrum.Api.error/0. Options :before (Nostrum.Snowflake.t/0) - get guilds before this guild ID :after (Nostrum.Snowflake.t/0) - get guilds after this guild ID :limit (integer) - max number of guilds to return (1-100) Examples iex&gt; Nostrum.Api.get_current_user_guilds(limit: 1) {:ok, [%Nostrum.Struct.Guild{}]}"},{"ref":"Nostrum.Api.html#get_current_user_guilds!/1","title":"Nostrum.Api.get_current_user_guilds!/1","type":"function","doc":"Same as get_current_user_guilds/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild/1","title":"Nostrum.Api.get_guild/1","type":"function","doc":"Gets a guild. If successful, returns {:ok, guild}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_guild(81384788765712384) {:ok, %Nostrum.Struct.Guild{id: 81384788765712384}}"},{"ref":"Nostrum.Api.html#get_guild!/1","title":"Nostrum.Api.get_guild!/1","type":"function","doc":"Same as get_guild/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_audit_log/2","title":"Nostrum.Api.get_guild_audit_log/2","type":"function","doc":"Get the Nostrum.Struct.Guild.AuditLog.t/0 for the given guild_id. Options :user_id (Nostrum.Struct.User.id/0) - filter the log for a user ID :action_type (Integer.t/0) - filter the log by audit log type, see Audit Log Events :before (t:Nostrum.Struct.Snowflake.t/0) - filter the log before a certain entry ID :limit (t:positive_integer/0) - how many entries are returned (default 50, minimum 1, maximum 100)"},{"ref":"Nostrum.Api.html#get_guild_bans/1","title":"Nostrum.Api.get_guild_bans/1","type":"function","doc":"Gets a list of users banend from a guild. Guild to get bans for is specified by guild_id."},{"ref":"Nostrum.Api.html#get_guild_channels/1","title":"Nostrum.Api.get_guild_channels/1","type":"function","doc":"Gets a list of guild channels. If successful, returns {:ok, channels}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_guild_channels(81384788765712384) {:ok, [%Nostrum.Struct.Channel{guild_id: 81384788765712384} | _]}"},{"ref":"Nostrum.Api.html#get_guild_channels!/1","title":"Nostrum.Api.get_guild_channels!/1","type":"function","doc":"Same as get_guild_channels/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_embed/1","title":"Nostrum.Api.get_guild_embed/1","type":"function","doc":"Gets a guild embed."},{"ref":"Nostrum.Api.html#get_guild_emoji/2","title":"Nostrum.Api.get_guild_emoji/2","type":"function","doc":"Gets an emoji for the given guild and emoji ids. This endpoint requires the MANAGE_EMOJIS permission. If successful, returns {:ok, emoji}. Otherwise, returns Nostrum.Api.error/0."},{"ref":"Nostrum.Api.html#get_guild_emoji!/2","title":"Nostrum.Api.get_guild_emoji!/2","type":"function","doc":"Same as get_guild_emoji/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_integrations/1","title":"Nostrum.Api.get_guild_integrations/1","type":"function","doc":"Gets a list of guild integerations. Guild to get integrations for is specified by guild_id."},{"ref":"Nostrum.Api.html#get_guild_invites/1","title":"Nostrum.Api.get_guild_invites/1","type":"function","doc":"Gets a list of invites for a guild. This endpoint requires the MANAGE_GUILD permission. If successful, returns {:ok, invites}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_guild_invites(81384788765712384) {:ok, [%Nostrum.Struct.Invite{} | _]}"},{"ref":"Nostrum.Api.html#get_guild_invites!/1","title":"Nostrum.Api.get_guild_invites!/1","type":"function","doc":"Same as get_guild_invites/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_member/2","title":"Nostrum.Api.get_guild_member/2","type":"function","doc":"Gets a guild member. If successful, returns {:ok, member}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_guild_member(4019283754613, 184937267485)"},{"ref":"Nostrum.Api.html#get_guild_member!/2","title":"Nostrum.Api.get_guild_member!/2","type":"function","doc":"Same as get_guild_member/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_prune_count/2","title":"Nostrum.Api.get_guild_prune_count/2","type":"function","doc":"Gets the number of members that would be removed in a prune given days. This endpoint requires the KICK_MEMBERS permission. If successful, returns {:ok, %{pruned: pruned}}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_guild_prune_count(81384788765712384, 1) {:ok, %{pruned: 0}}"},{"ref":"Nostrum.Api.html#get_guild_prune_count!/2","title":"Nostrum.Api.get_guild_prune_count!/2","type":"function","doc":"Same as get_guild_prune_count/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_roles/1","title":"Nostrum.Api.get_guild_roles/1","type":"function","doc":"Gets a guild&#39;s roles. If successful, returns {:ok, roles}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_guild_roles(147362948571673)"},{"ref":"Nostrum.Api.html#get_guild_roles!/1","title":"Nostrum.Api.get_guild_roles!/1","type":"function","doc":"Same as get_guild_roles/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_guild_webhooks/1","title":"Nostrum.Api.get_guild_webhooks/1","type":"function","doc":"Gets a list of webooks for a guild. Parameters guild_id - Guild to get webhooks for."},{"ref":"Nostrum.Api.html#get_invite/1","title":"Nostrum.Api.get_invite/1","type":"function","doc":"Gets an invite by its invite_code. If successful, returns {:ok, invite}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_invite(&quot;zsjUsC&quot;) {:ok, %Nostrum.Struct.Invite{code: &quot;zsjUsC&quot;}}"},{"ref":"Nostrum.Api.html#get_invite!/1","title":"Nostrum.Api.get_invite!/1","type":"function","doc":"Same as get_invite/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_pinned_messages/1","title":"Nostrum.Api.get_pinned_messages/1","type":"function","doc":"Retrieves all pinned messages from a channel. This endpoint requires the &#39;VIEW_CHANNEL&#39; and &#39;READ_MESSAGE_HISTORY&#39; permissions. If successful, returns {:ok, messages}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_pinned_messages(43189401384091)"},{"ref":"Nostrum.Api.html#get_pinned_messages!/1","title":"Nostrum.Api.get_pinned_messages!/1","type":"function","doc":"Same as get_pinned_messages/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_reactions/3","title":"Nostrum.Api.get_reactions/3","type":"function","doc":"Gets all users who reacted with an emoji. This endpoint requires the VIEW_CHANNEL and READ_MESSAGE_HISTORY permissions. If successful, returns {:ok, users}. Otherwise, returns Nostrum.Api.error/0. See create_reaction/3 for similar examples."},{"ref":"Nostrum.Api.html#get_reactions!/3","title":"Nostrum.Api.get_reactions!/3","type":"function","doc":"Same as get_reactions/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_token/0","title":"Nostrum.Api.get_token/0","type":"function","doc":"Returns the token of the bot."},{"ref":"Nostrum.Api.html#get_user/1","title":"Nostrum.Api.get_user/1","type":"function","doc":"Gets a user by its Nostrum.Struct.User.id/0. If the request is successful, this function returns {:ok, user}, where user is a Nostrum.Struct.User. Otherwise, returns {:error, reason}."},{"ref":"Nostrum.Api.html#get_user!/1","title":"Nostrum.Api.get_user!/1","type":"function","doc":"Same as get_user/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_user_connections/0","title":"Nostrum.Api.get_user_connections/0","type":"function","doc":"Gets a list of user connections."},{"ref":"Nostrum.Api.html#get_user_dms/0","title":"Nostrum.Api.get_user_dms/0","type":"function","doc":"Gets a list of our user&#39;s DM channels. If successful, returns {:ok, dm_channels}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.get_user_dms() {:ok, [%Nostrum.Struct.Channel{type: 1} | _]}"},{"ref":"Nostrum.Api.html#get_user_dms!/0","title":"Nostrum.Api.get_user_dms!/0","type":"function","doc":"Same as get_user_dms/0, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#get_voice_region/1","title":"Nostrum.Api.get_voice_region/1","type":"function","doc":"Gets a list of voice regions for the guild. Guild to get voice regions for is specified by guild_id."},{"ref":"Nostrum.Api.html#get_webhook/1","title":"Nostrum.Api.get_webhook/1","type":"function","doc":"Gets a webhook by id. Parameters webhook_id - Id of the webhook to get."},{"ref":"Nostrum.Api.html#get_webhook_with_token/2","title":"Nostrum.Api.get_webhook_with_token/2","type":"function","doc":"Gets a webhook by id and token. This method is exactly like get_webhook/1 but does not require authentication. Parameters webhook_id - Id of the webhook to get. webhook_token - Token of the webhook to get."},{"ref":"Nostrum.Api.html#leave_guild/1","title":"Nostrum.Api.leave_guild/1","type":"function","doc":"Leaves a guild. Guild to leave is specified by guild_id."},{"ref":"Nostrum.Api.html#list_guild_emojis/1","title":"Nostrum.Api.list_guild_emojis/1","type":"function","doc":"Gets a list of emojis for a given guild. This endpoint requires the MANAGE_EMOJIS permission. If successful, returns {:ok, emojis}. Otherwise, returns Nostrum.Api.error/0."},{"ref":"Nostrum.Api.html#list_guild_emojis!/1","title":"Nostrum.Api.list_guild_emojis!/1","type":"function","doc":"Same as list_guild_emojis/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#list_guild_members/2","title":"Nostrum.Api.list_guild_members/2","type":"function","doc":"Gets a list of a guild&#39;s members. If successful, returns {:ok, members}. Otherwise, returns a Nostrum.Api.error/0. Options :limit (integer) - max number of members to return (1-1000) (default: 1) :after (Nostrum.Struct.User.id/0) - the highest user id in the previous page (default: 0) Examples Nostrum.Api.list_guild_members(41771983423143937, limit: 1)"},{"ref":"Nostrum.Api.html#list_guild_members!/2","title":"Nostrum.Api.list_guild_members!/2","type":"function","doc":"Same as list_guild_members/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#list_voice_regions/0","title":"Nostrum.Api.list_voice_regions/0","type":"function","doc":"Gets a list of voice regions."},{"ref":"Nostrum.Api.html#modify_channel/3","title":"Nostrum.Api.modify_channel/3","type":"function","doc":"Modifies a channel&#39;s settings. An optional reason can be given for the guild audit log. If a Nostrum.Struct.Channel.guild_channel/0 is being modified, this endpoint requires the MANAGE_CHANNEL permission. It fires a Nostrum.Consumer.channel_update/0 event. If a Nostrum.Struct.Channel.channel_category/0 is being modified, then this endpoint fires multiple Nostrum.Consumer.channel_update/0 events. If successful, returns {:ok, channel}. Otherwise, returns a Nostrum.Api.error/0. Options :name (string) - 2-100 character channel name :position (integer) - the position of the channel in the left-hand listing :topic (string) (Nostrum.Struct.Channel.text_channel/0 only) - 0-1024 character channel topic :nsfw (boolean) (Nostrum.Struct.Channel.text_channel/0 only) - if the channel is nsfw :bitrate (integer) (Nostrum.Struct.Channel.voice_channel/0 only) - the bitrate (in bits) of the voice channel; 8000 to 96000 (128000 for VIP servers) :user_limit (integer) (Nostrum.Struct.Channel.voice_channel/0 only) - the user limit of the voice channel; 0 refers to no limit, 1 to 99 refers to a user limit :permission_overwrites (list of Nostrum.Struct.Overwrite.t/0 or equivalent map) - channel or category-specific permissions :parent_id (Nostrum.Struct.Channel.id/0) (Nostrum.Struct.Channel.guild_channel/0 only) - id of the new parent category for a channel Examples Nostrum.Api.modify_channel(41771983423143933, name: &quot;elixir-nostrum&quot;, topic: &quot;nostrum discussion&quot;) {:ok, %Nostrum.Struct.Channel{id: 41771983423143933, name: &quot;elixir-nostrum&quot;, topic: &quot;nostrum discussion&quot;}} Nostrum.Api.modify_channel(41771983423143933) {:ok, %Nostrum.Struct.Channel{id: 41771983423143933}}"},{"ref":"Nostrum.Api.html#modify_channel!/3","title":"Nostrum.Api.modify_channel!/3","type":"function","doc":"Same as modify_channel/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_current_user/1","title":"Nostrum.Api.modify_current_user/1","type":"function","doc":"Changes the username or avatar of the current user. Options :username (string) - new username :avatar (string) - the user&#39;s avatar as avatar data Examples Nostrum.Api.modify_current_user(avatar: &quot;data:image/jpeg;base64,YXl5IGJieSB1IGx1a2luIDQgc3VtIGZ1az8=&quot;)"},{"ref":"Nostrum.Api.html#modify_current_user!/1","title":"Nostrum.Api.modify_current_user!/1","type":"function","doc":"Same as modify_current_user/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_guild/3","title":"Nostrum.Api.modify_guild/3","type":"function","doc":"Modifies a guild&#39;s settings. This endpoint requires the MANAGE_GUILD permission. It fires the Nostrum.Consumer.guild_update/0 event. An optional reason can be provided for the audit log. If successful, returns {:ok, guild}. Otherwise, returns a Nostrum.Api.error/0. Options :name (string) - guild name :region (string) - guild voice region id :verification_level (integer) - verification level :default_message_notifications (integer) - default message notification level :explicit_content_filter (integer) - explicit content filter level :afk_channel_id (Nostrum.Snowflake.t/0) - id for afk channel :afk_timeout (integer) - afk timeout in seconds :icon (base64 data URI) - 128x128 jpeg image for the guild icon :owner_id (Nostrum.Snowflake.t/0) - user id to transfer guild ownership to (must be owner) :splash (base64 data URI) - 128x128 jpeg image for the guild splash (VIP only) :system_channel_id (Nostrum.Snowflake.t/0) - the id of the channel to which system messages are sent Examples Nostrum.Api.modify_guild(451824027976073216, name: &quot;Nose Drum&quot;) {:ok, %Nostrum.Struct.Guild{id: 451824027976073216, name: &quot;Nose Drum&quot;, ...}}"},{"ref":"Nostrum.Api.html#modify_guild!/2","title":"Nostrum.Api.modify_guild!/2","type":"function","doc":"Same as modify_guild/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_guild_channel_positions/2","title":"Nostrum.Api.modify_guild_channel_positions/2","type":"function","doc":"Reorders a guild&#39;s channels. This endpoint requires the MANAGE_CHANNELS permission. It fires multiple Nostrum.Consumer.channel_update/0 events. If successful, returns {:ok, channels}. Otherwise, returns a Nostrum.Api.error/0. positions is a list of maps that each map a channel id with a position. Examples Nostrum.Api.modify_guild_channel_positions(279093381723062272, [%{id: 351500354581692420, position: 2}]) {:ok}"},{"ref":"Nostrum.Api.html#modify_guild_channel_positions!/2","title":"Nostrum.Api.modify_guild_channel_positions!/2","type":"function","doc":"Same as modify_guild_channel_positions/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_guild_embed/2","title":"Nostrum.Api.modify_guild_embed/2","type":"function","doc":"Modifies a guild imbed."},{"ref":"Nostrum.Api.html#modify_guild_emoji/4","title":"Nostrum.Api.modify_guild_emoji/4","type":"function","doc":"Modify the given emoji. This endpoint requires the MANAGE_EMOJIS permission. It fires a Nostrum.Consumer.guild_emojis_update/0 event. An optional reason can be provided for the audit log. If successful, returns {:ok, emoji}. Otherwise, returns Nostrum.Api.error/0. Options :name (string) - name of the emoji :roles (list of Nostrum.Snowflake.t/0) - roles to which this emoji will be whitelisted Examples Nostrum.Api.modify_guild_emoji(43189401384091, 4314301984301, name: &quot;elixir&quot;, roles: [])"},{"ref":"Nostrum.Api.html#modify_guild_emoji!/4","title":"Nostrum.Api.modify_guild_emoji!/4","type":"function","doc":"Same as modify_guild_emoji/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_guild_integrations/3","title":"Nostrum.Api.modify_guild_integrations/3","type":"function","doc":"Changes the settings and behaviours for a guild integeration. Integration to modify is specified by guild_id and integeration_id. options is a map with the following keys: expire_behavior - Expiry behavior. expire_grace_period - Period where the integration will ignore elapsed subs. enable_emoticons - Whether emoticons should be synced."},{"ref":"Nostrum.Api.html#modify_guild_member/3","title":"Nostrum.Api.modify_guild_member/3","type":"function","doc":"Modifies a guild member&#39;s attributes. This endpoint fires the Nostrum.Consumer.guild_member_update/0 event. It situationally requires the MANAGE_NICKNAMES, MANAGE_ROLES, MUTE_MEMBERS, DEAFEN_MEMBERS, and MOVE_MEMBERS permissions. If successful, returns {:ok}. Otherwise, returns a Nostrum.Api.error/0. Options :nick (string) - value to set users nickname to :roles (list of Nostrum.Snowflake.t/0) - array of role ids the member is assigned :mute (boolean) - if the user is muted :deaf (boolean) - if the user is deafened :channel_id (Nostrum.Snowflake.t/0) - id of channel to move user to (if they are connected to voice) Examples Nostrum.Api.modify_guild_member(41771983423143937, 637162356451, nick: &quot;Nostrum&quot;) {:ok}"},{"ref":"Nostrum.Api.html#modify_guild_member!/3","title":"Nostrum.Api.modify_guild_member!/3","type":"function","doc":"Same as modify_guild_member/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_guild_role/4","title":"Nostrum.Api.modify_guild_role/4","type":"function","doc":"Modifies a guild role. This endpoint requires the MANAGE_ROLES permission. It fires a Nostrum.Consumer.guild_role_update/0 event. An optional reason can be specified for the audit log. If successful, returns {:ok, role}. Otherwise, returns a Nostrum.Api.error/0. Options :name (string) - name of the role :permissions (integer) - bitwise of the enabled/disabled permissions :color (integer) - RGB color value (default: 0) :hoist (boolean) - whether the role should be displayed separately in the sidebar :mentionable (boolean) - whether the role should be mentionable Examples Nostrum.Api.modify_guild_role(41771983423143937, 392817238471936, hoist: false, name: &quot;foo-bar&quot;)"},{"ref":"Nostrum.Api.html#modify_guild_role!/4","title":"Nostrum.Api.modify_guild_role!/4","type":"function","doc":"Same as modify_guild_role/3, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_guild_role_positions/3","title":"Nostrum.Api.modify_guild_role_positions/3","type":"function","doc":"Reorders a guild&#39;s roles. This endpoint requires the MANAGE_ROLES permission. It fires multiple Nostrum.Consumer.guild_role_update/0 events. If successful, returns {:ok, roles}. Otherwise, returns a Nostrum.Api.error/0. positions is a list of maps that each map a role id with a position. Examples Nostrum.Api.modify_guild_role_positions(41771983423143937, [%{id: 41771983423143936, position: 2}])"},{"ref":"Nostrum.Api.html#modify_guild_role_positions!/3","title":"Nostrum.Api.modify_guild_role_positions!/3","type":"function","doc":"Same as modify_guild_role_positions/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#modify_webhook/3","title":"Nostrum.Api.modify_webhook/3","type":"function","doc":"Modifies a webhook. Parameters webhook_id - Id of the webhook to modify. args - Map with the following optional keys: name - Name of the webhook. avatar - Base64 128x128 jpeg image for the default avatar. reason - An optional reason for the guild audit log."},{"ref":"Nostrum.Api.html#modify_webhook_with_token/4","title":"Nostrum.Api.modify_webhook_with_token/4","type":"function","doc":"Modifies a webhook with a token. This method is exactly like modify_webhook/1 but does not require authentication. Parameters webhook_id - Id of the webhook to modify. webhook_token - Token of the webhook to get. args - Map with the following optional keys: name - Name of the webhook. avatar - Base64 128x128 jpeg image for the default avatar. reason - An optional reason for the guild audit log."},{"ref":"Nostrum.Api.html#remove_guild_ban/3","title":"Nostrum.Api.remove_guild_ban/3","type":"function","doc":"Removes a ban for a user. User to unban is specified by guild_id and user_id. An optional reason can be specified for the audit log."},{"ref":"Nostrum.Api.html#remove_guild_member/3","title":"Nostrum.Api.remove_guild_member/3","type":"function","doc":"Removes a member from a guild. This event requires the KICK_MEMBERS permission. It fires a Nostrum.Consumer.guild_member_remove/0 event. An optional reason can be provided for the audit log with reason. If successful, returns {:ok}. Otherwise, returns a Nostrum.Api.error/0. Examples Nostrum.Api.remove_guild_member(1453827904102291, 18739485766253) {:ok}"},{"ref":"Nostrum.Api.html#remove_guild_member!/3","title":"Nostrum.Api.remove_guild_member!/3","type":"function","doc":"Same as remove_guild_member/2, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#remove_guild_member_role/4","title":"Nostrum.Api.remove_guild_member_role/4","type":"function","doc":"Removes a role from a member. Role to remove is specified by role_id. User to remove role from is specified by guild_id and user_id. An optional reason can be given for the audit log."},{"ref":"Nostrum.Api.html#request/1","title":"Nostrum.Api.request/1","type":"function","doc":""},{"ref":"Nostrum.Api.html#request/4","title":"Nostrum.Api.request/4","type":"function","doc":""},{"ref":"Nostrum.Api.html#request_multipart/4","title":"Nostrum.Api.request_multipart/4","type":"function","doc":""},{"ref":"Nostrum.Api.html#start_typing/1","title":"Nostrum.Api.start_typing/1","type":"function","doc":"Triggers the typing indicator. Triggers the typing indicator in the channel specified by channel_id. The typing indicator lasts for about 8 seconds and then automatically stops. Returns {:ok} if successful. error otherwise."},{"ref":"Nostrum.Api.html#start_typing!/1","title":"Nostrum.Api.start_typing!/1","type":"function","doc":"Same as start_typing/1, but raises Nostrum.Error.ApiError in case of failure."},{"ref":"Nostrum.Api.html#sync_guild_integrations/2","title":"Nostrum.Api.sync_guild_integrations/2","type":"function","doc":"Syncs a guild integration. Integration to sync is specified by guild_id and integeration_id."},{"ref":"Nostrum.Api.html#update_shard_status/5","title":"Nostrum.Api.update_shard_status/5","type":"function","doc":"Updates the status of the bot for a certain shard. Parameters pid - Pid of the shard. status - Status of the bot. game - The &#39;playing&#39; text of the bot. Empty will clear. type - The type of status to show. 0 (Playing) | 1 (Streaming) | 2 (Listening) | 3 (Watching) stream - URL of twitch.tv stream"},{"ref":"Nostrum.Api.html#update_status/4","title":"Nostrum.Api.update_status/4","type":"function","doc":"Updates the status of the bot for all shards. See update_shard_status/5 for usage."},{"ref":"Nostrum.Api.html#update_voice_state/4","title":"Nostrum.Api.update_voice_state/4","type":"function","doc":"Joins, moves, or disconnects the bot from a voice channel. The correct shard to send the update to will be inferred from the guild_id. If a corresponding guild_id is not found a cache error will be raised. To disconnect from a channel, channel_id should be set to nil."},{"ref":"Nostrum.Api.html#t:emoji/0","title":"Nostrum.Api.emoji/0","type":"type","doc":"Represents an emoji for interacting with reaction endpoints."},{"ref":"Nostrum.Api.html#t:error/0","title":"Nostrum.Api.error/0","type":"type","doc":"Represents a failed response from the API. This occurs when hackney or HTTPoison fail, or when the API doesn&#39;t respond with 200 or 204."},{"ref":"Nostrum.Api.html#t:limit/0","title":"Nostrum.Api.limit/0","type":"type","doc":"Represents a limit used to retrieve messages. Integer number of messages, or :infinity to retrieve all messages."},{"ref":"Nostrum.Api.html#t:locator/0","title":"Nostrum.Api.locator/0","type":"type","doc":"Represents a tuple used to locate messages. The first element of the tuple is an atom. The second element will be a message_id as an integer. The tuple can also be empty to search from the most recent message in the channel"},{"ref":"Nostrum.Api.html#t:options/0","title":"Nostrum.Api.options/0","type":"type","doc":"Represents optional parameters for Api functions. Each function has documentation regarding what parameters it supports or needs."},{"ref":"Nostrum.Api.html#t:status/0","title":"Nostrum.Api.status/0","type":"type","doc":"Represents different statuses the bot can have. :dnd - Red circle. :idle - Yellow circle. :online - Green circle. :invisible - The bot will appear offline."},{"ref":"Nostrum.Api.Ratelimiter.html","title":"Nostrum.Api.Ratelimiter","type":"module","doc":"Ratelimit implimentation specific to Discord&#39;s API. Only to be used when starting in a rest-only manner."},{"ref":"Nostrum.Api.Ratelimiter.html#child_spec/1","title":"Nostrum.Api.Ratelimiter.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Nostrum.Api.Ratelimiter.html#empty_buckets/0","title":"Nostrum.Api.Ratelimiter.empty_buckets/0","type":"function","doc":"Empties all buckets, voiding any saved ratelimit values."},{"ref":"Nostrum.Api.Ratelimiter.html#get_endpoint/2","title":"Nostrum.Api.Ratelimiter.get_endpoint/2","type":"function","doc":"Retrieves a proper ratelimit endpoint from a given route and url."},{"ref":"Nostrum.Api.Ratelimiter.html#init/1","title":"Nostrum.Api.Ratelimiter.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Nostrum.Api.Ratelimiter.html#start_link/1","title":"Nostrum.Api.Ratelimiter.start_link/1","type":"function","doc":"Starts the ratelimiter."},{"ref":"Nostrum.Api.Ratelimiter.html#t:on_start/0","title":"Nostrum.Api.Ratelimiter.on_start/0","type":"type","doc":"Return values of start functions."},{"ref":"Nostrum.Cache.ChannelCache.html","title":"Nostrum.Cache.ChannelCache","type":"module","doc":"Cache for channels. The ETS table name associated with the Channel Cache is :channels. Besides the methods provided below you can call any other ETS methods on the table. Example info = :ets.info(:channels) [..., heir: :none, name: :channels, size: 1, ...] size = info[:size] 1"},{"ref":"Nostrum.Cache.ChannelCache.html#get/1","title":"Nostrum.Cache.ChannelCache.get/1","type":"function","doc":"Retrieves a channel from the cache. Internally, the ChannelCache process only stores Nostrum.Struct.Channel.dm_channel/0 references. To get channel information, a call is made to a Nostrum.Cache.GuildCache. If successful, returns {:ok, channel}. Otherwise, returns {:error, reason} Example case Nostrum.Cache.ChannelCache.get(133333333337) do {:ok, channel} -&gt; &quot;We found &quot; &lt;&gt; channel.name {:error, _reason} -&gt; &quot;Donde esta&quot; end"},{"ref":"Nostrum.Cache.ChannelCache.html#get!/1","title":"Nostrum.Cache.ChannelCache.get!/1","type":"function","doc":"Same as get/1, but raises Nostrum.Error.CacheError in case of a failure."},{"ref":"Nostrum.Cache.GuildCache.html","title":"Nostrum.Cache.GuildCache","type":"module","doc":"Functions for retrieving guild states."},{"ref":"Nostrum.Cache.GuildCache.html#all/0","title":"Nostrum.Cache.GuildCache.all/0","type":"function","doc":"Retrives all Nostrum.Struct.Guild from the cache as a stream."},{"ref":"Nostrum.Cache.GuildCache.html#get/1","title":"Nostrum.Cache.GuildCache.get/1","type":"function","doc":"Retrives a single Nostrum.Struct.Guild from the cache via its id. Returns {:error, reason} if no result was found. Examples iex&gt; Nostrum.Cache.GuildCache.get(0) {:ok, %Nostrum.Struct.Guild{id: 0}} iex&gt; Nostrum.Cache.GuildCache.get(10) {:error, :id_not_found_on_guild_lookup}"},{"ref":"Nostrum.Cache.GuildCache.html#get!/1","title":"Nostrum.Cache.GuildCache.get!/1","type":"function","doc":"Same as get/1, but raises Nostrum.Error.CacheError in case of failure."},{"ref":"Nostrum.Cache.GuildCache.html#get_by/1","title":"Nostrum.Cache.GuildCache.get_by/1","type":"function","doc":"Retrives a single Nostrum.Struct.Guild where it matches the clauses. Returns {:error, reason} if no result was found. iex&gt; Nostrum.Cache.GuildCache.get_by(id: 0) {:ok, %Nostrum.Struct.Guild{id: 0}} iex&gt; Nostrum.Cache.GuildCache.get_by(%{id: 0}) {:ok, %Nostrum.Struct.Guild{id: 0}} iex&gt; Nostrum.Cache.GuildCache.get_by(id: 10) {:error, :id_not_found_on_guild_lookup}"},{"ref":"Nostrum.Cache.GuildCache.html#get_by!/1","title":"Nostrum.Cache.GuildCache.get_by!/1","type":"function","doc":"Same as get_by/1, but raises Nostrum.Error.CacheError in case of failure."},{"ref":"Nostrum.Cache.GuildCache.html#select/2","title":"Nostrum.Cache.GuildCache.select/2","type":"function","doc":"Selects values using a selector from a Nostrum.Struct.Guild. Returns {:error, reason} if no result was found. Examples iex&gt; Nostrum.Cache.GuildCache.select(0, fn guild -&gt; guild.id end) {:ok, 0} iex&gt; Nostrum.Cache.GuildCache.select(10, fn guild -&gt; guild.id end) {:error, :id_not_found_on_guild_lookup}"},{"ref":"Nostrum.Cache.GuildCache.html#select!/2","title":"Nostrum.Cache.GuildCache.select!/2","type":"function","doc":"Same as select/2, but raises Nostrum.Error.CacheError in case of failure."},{"ref":"Nostrum.Cache.GuildCache.html#select_all/1","title":"Nostrum.Cache.GuildCache.select_all/1","type":"function","doc":"Selects values using a selector from all Nostrum.Struct.Guild in the cache."},{"ref":"Nostrum.Cache.GuildCache.html#select_by/2","title":"Nostrum.Cache.GuildCache.select_by/2","type":"function","doc":"Selects values using a selector from a Nostrum.Struct.Guild that matches the clauses. Returns {:error, reason} if no result was found. iex&gt; Nostrum.Cache.GuildCache.select_by([id: 0], fn guild -&gt; guild.id end) {:ok, 0} iex&gt; Nostrum.Cache.GuildCache.select_by(%{id: 0}, fn guild -&gt; guild.id end) {:ok, 0} iex&gt; Nostrum.Cache.GuildCache.select_by([id: 10], fn guild -&gt; guild.id end) {:error, :id_not_found_on_guild_lookup}"},{"ref":"Nostrum.Cache.GuildCache.html#select_by!/2","title":"Nostrum.Cache.GuildCache.select_by!/2","type":"function","doc":"Same as select_by/2, but raises Nostrum.Error.CacheError in case of failure."},{"ref":"Nostrum.Cache.GuildCache.html#t:clause/0","title":"Nostrum.Cache.GuildCache.clause/0","type":"type","doc":""},{"ref":"Nostrum.Cache.GuildCache.html#t:clauses/0","title":"Nostrum.Cache.GuildCache.clauses/0","type":"type","doc":""},{"ref":"Nostrum.Cache.GuildCache.html#t:reason/0","title":"Nostrum.Cache.GuildCache.reason/0","type":"type","doc":""},{"ref":"Nostrum.Cache.GuildCache.html#t:selector/0","title":"Nostrum.Cache.GuildCache.selector/0","type":"type","doc":""},{"ref":"Nostrum.Cache.Mapping.ChannelGuild.html","title":"Nostrum.Cache.Mapping.ChannelGuild","type":"module","doc":"Mapping of channel -&gt; guild relationships. Given just the id of a guild channel, there&#39;s no way to know what guild it belongs to. This mapping is an ETS table that stores this information."},{"ref":"Nostrum.Cache.Mapping.ChannelGuild.html#get_guild/1","title":"Nostrum.Cache.Mapping.ChannelGuild.get_guild/1","type":"function","doc":"Gets a guild_id from a channel_id."},{"ref":"Nostrum.Cache.Mapping.GuildShard.html","title":"Nostrum.Cache.Mapping.GuildShard","type":"module","doc":"Mapping of guild -&gt; shard relationships. Guild servers do not inherently know which shard they came from. This mapping is an ETS table that stores this information."},{"ref":"Nostrum.Cache.Mapping.GuildShard.html#get_shard/1","title":"Nostrum.Cache.Mapping.GuildShard.get_shard/1","type":"function","doc":"Gets the a shard num from a guild_id."},{"ref":"Nostrum.Cache.Mapping.ShardPidNum.html","title":"Nostrum.Cache.Mapping.ShardPidNum","type":"module","doc":"Simple mapping of shard pid to num"},{"ref":"Nostrum.Cache.Mapping.ShardPidNum.html#get_pid/1","title":"Nostrum.Cache.Mapping.ShardPidNum.get_pid/1","type":"function","doc":"Gets the a shard pid from a shard number."},{"ref":"Nostrum.Cache.Me.html","title":"Nostrum.Cache.Me","type":"module","doc":"Simple cache that stores information for the current user."},{"ref":"Nostrum.Cache.Me.html#child_spec/1","title":"Nostrum.Cache.Me.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Nostrum.Cache.Me.html#get/0","title":"Nostrum.Cache.Me.get/0","type":"function","doc":"Returns the current user&#39;s state."},{"ref":"Nostrum.Cache.Me.html#start_link/1","title":"Nostrum.Cache.Me.start_link/1","type":"function","doc":""},{"ref":"Nostrum.Cache.PresenceCache.html","title":"Nostrum.Cache.PresenceCache","type":"module","doc":"Cache for presences. The ETS table name associated with the User Cache is :presences. Besides the methods provided below you can call any other ETS methods on the table. Example info = :ets.info(:presences) [..., heir: :none, name: :presences, size: 1, ...] size = info[:size] 1"},{"ref":"Nostrum.Cache.PresenceCache.html#get/2","title":"Nostrum.Cache.PresenceCache.get/2","type":"function","doc":"Retreives a presence for a user from the cache by guild and id. If successful, returns {:ok, presence}. Otherwise returns {:error, reason}. Example case Nostrum.Cache.PresenceCache.get(111133335555, 222244446666) do {:ok, presence} -&gt; &quot;They&#39;re \#{presence.status}&quot; {:error, _reason} -&gt; &quot;They&#39;re dead Jim&quot; end"},{"ref":"Nostrum.Cache.PresenceCache.html#get!/2","title":"Nostrum.Cache.PresenceCache.get!/2","type":"function","doc":"Same as get/1, but raises Nostrum.Error.CacheError in case of a failure."},{"ref":"Nostrum.Cache.UserCache.html","title":"Nostrum.Cache.UserCache","type":"module","doc":"Cache for users. The ETS table name associated with the User Cache is :users. Besides the methods provided below you can call any other ETS methods on the table. Example info = :ets.info(:users) [..., heir: :none, name: :users, size: 1, ...] size = info[:size] 1"},{"ref":"Nostrum.Cache.UserCache.html#get/1","title":"Nostrum.Cache.UserCache.get/1","type":"function","doc":"Retrieves a user from the cache by id. If successful, returns {:ok, user}. Otherwise, returns {:error, reason}. Example case Nostrum.Cache.UserCache.get(1111222233334444) do {:ok, user} -&gt; &quot;We found &quot; &lt;&gt; user.username {:error, _reason} -&gt; &quot;No es bueno&quot; end"},{"ref":"Nostrum.Cache.UserCache.html#get!/1","title":"Nostrum.Cache.UserCache.get!/1","type":"function","doc":"Same as get/1, but raises Nostrum.Error.CacheError in case of a failure."},{"ref":"Nostrum.Struct.Channel.html","title":"Nostrum.Struct.Channel","type":"module","doc":"Struct representing a Discord guild channel. A Nostrum.Struct.Channel represents all 5 types of channels. Each channel has a field :type with any of the following values: 0 - GUILD_TEXT 1 - DM 2 - GUILD_VOICE 3 - GROUP_DM 4 - GUILD_CATEGORY More information can be found on the Discord API Channel Documentation. Mentioning Channels in Messages A Nostrum.Struct.Channel can be mentioned in message content using the String.Chars protocol or mention/1. channel = %Nostrum.Struct.Channel{id: 381889573426429952} Nostrum.Api.create_message!(184046599834435585, &quot;\#{channel}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;#381889573426429952&gt;&quot;} channel = %Nostrum.Struct.Channel{id: 280085880452939778} Nostrum.Api.create_message!(280085880452939778, &quot;\#{Nostrum.Struct.Channel.mention(channel)}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;#280085880452939778&gt;&quot;}"},{"ref":"Nostrum.Struct.Channel.html#mention/1","title":"Nostrum.Struct.Channel.mention/1","type":"function","doc":"Formats a Nostrum.Struct.Channel into a mention. Examples iex&gt; channel = %Nostrum.Struct.Channel{id: 381889573426429952} ...&gt; Nostrum.Struct.Channel.mention(channel) &quot;&lt;#381889573426429952&gt;&quot;"},{"ref":"Nostrum.Struct.Channel.html#t:application_id/0","title":"Nostrum.Struct.Channel.application_id/0","type":"type","doc":"The application id of the group DM creator if it is bot-created"},{"ref":"Nostrum.Struct.Channel.html#t:bitrate/0","title":"Nostrum.Struct.Channel.bitrate/0","type":"type","doc":"The bitrate of the voice channel"},{"ref":"Nostrum.Struct.Channel.html#t:channel_category/0","title":"Nostrum.Struct.Channel.channel_category/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a channel category in a guild."},{"ref":"Nostrum.Struct.Channel.html#t:dm_channel/0","title":"Nostrum.Struct.Channel.dm_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a DM channel."},{"ref":"Nostrum.Struct.Channel.html#t:group_dm_channel/0","title":"Nostrum.Struct.Channel.group_dm_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a group DM channel."},{"ref":"Nostrum.Struct.Channel.html#t:guild_channel/0","title":"Nostrum.Struct.Channel.guild_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a channel in a guild."},{"ref":"Nostrum.Struct.Channel.html#t:guild_id/0","title":"Nostrum.Struct.Channel.guild_id/0","type":"type","doc":"The id of the channel&#39;s guild"},{"ref":"Nostrum.Struct.Channel.html#t:guild_text_channel/0","title":"Nostrum.Struct.Channel.guild_text_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a text channel in a guild."},{"ref":"Nostrum.Struct.Channel.html#t:guild_voice_channel/0","title":"Nostrum.Struct.Channel.guild_voice_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a voice channel in a guild."},{"ref":"Nostrum.Struct.Channel.html#t:icon/0","title":"Nostrum.Struct.Channel.icon/0","type":"type","doc":"The icon hash of the channel"},{"ref":"Nostrum.Struct.Channel.html#t:id/0","title":"Nostrum.Struct.Channel.id/0","type":"type","doc":"The channel&#39;s id"},{"ref":"Nostrum.Struct.Channel.html#t:last_message_id/0","title":"Nostrum.Struct.Channel.last_message_id/0","type":"type","doc":"Id of the last message sent"},{"ref":"Nostrum.Struct.Channel.html#t:last_pin_timestamp/0","title":"Nostrum.Struct.Channel.last_pin_timestamp/0","type":"type","doc":"When the last pinned message was pinned"},{"ref":"Nostrum.Struct.Channel.html#t:name/0","title":"Nostrum.Struct.Channel.name/0","type":"type","doc":"The name of the channel"},{"ref":"Nostrum.Struct.Channel.html#t:nsfw/0","title":"Nostrum.Struct.Channel.nsfw/0","type":"type","doc":"If the channel is nsfw"},{"ref":"Nostrum.Struct.Channel.html#t:owner_id/0","title":"Nostrum.Struct.Channel.owner_id/0","type":"type","doc":"The id of the DM creator"},{"ref":"Nostrum.Struct.Channel.html#t:parent_id/0","title":"Nostrum.Struct.Channel.parent_id/0","type":"type","doc":"The id of the parent category for a channel"},{"ref":"Nostrum.Struct.Channel.html#t:permission_overwrites/0","title":"Nostrum.Struct.Channel.permission_overwrites/0","type":"type","doc":"The list of overwrites"},{"ref":"Nostrum.Struct.Channel.html#t:position/0","title":"Nostrum.Struct.Channel.position/0","type":"type","doc":"The ordered position of the channel"},{"ref":"Nostrum.Struct.Channel.html#t:recipients/0","title":"Nostrum.Struct.Channel.recipients/0","type":"type","doc":"The recipients of the DM"},{"ref":"Nostrum.Struct.Channel.html#t:t/0","title":"Nostrum.Struct.Channel.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Channel.html#t:text_channel/0","title":"Nostrum.Struct.Channel.text_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a text channel."},{"ref":"Nostrum.Struct.Channel.html#t:topic/0","title":"Nostrum.Struct.Channel.topic/0","type":"type","doc":"Current channel topic"},{"ref":"Nostrum.Struct.Channel.html#t:user_limit/0","title":"Nostrum.Struct.Channel.user_limit/0","type":"type","doc":"The user limit of the voice channel"},{"ref":"Nostrum.Struct.Channel.html#t:voice_channel/0","title":"Nostrum.Struct.Channel.voice_channel/0","type":"type","doc":"A Nostrum.Struct.Channel that represents a voice channel."},{"ref":"Nostrum.Struct.Embed.html","title":"Nostrum.Struct.Embed","type":"module","doc":"Functions that work on Discord embeds. Building Embeds Nostrum.Struct.Embeds can be built using this module&#39;s builder functions or standard Map syntax: iex&gt; import Nostrum.Struct.Embed ...&gt; embed = ...&gt; %Nostrum.Struct.Embed{} ...&gt; |&gt; put_title(&quot;craig&quot;) ...&gt; |&gt; put_description(&quot;nostrum&quot;) ...&gt; |&gt; put_url(&quot;https://google.com/&quot;) ...&gt; |&gt; put_timestamp(&quot;2016-05-05T21:04:13.203Z&quot;) ...&gt; |&gt; put_color(431_948) ...&gt; |&gt; put_field(&quot;Field 1&quot;, &quot;Test&quot;) ...&gt; |&gt; put_field(&quot;Field 2&quot;, &quot;More test&quot;, true) ...&gt; embed %Nostrum.Struct.Embed{ title: &quot;craig&quot;, description: &quot;nostrum&quot;, url: &quot;https://google.com/&quot;, timestamp: &quot;2016-05-05T21:04:13.203Z&quot;, color: 431_948, fields: [ %Nostrum.Struct.Embed.Field{name: &quot;Field 1&quot;, value: &quot;Test&quot;}, %Nostrum.Struct.Embed.Field{name: &quot;Field 2&quot;, value: &quot;More test&quot;, inline: true} ] }"},{"ref":"Nostrum.Struct.Embed.html#put_author/4","title":"Nostrum.Struct.Embed.put_author/4","type":"function","doc":"Puts a Nostrum.Struct.Embed.Author under :author in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_author(embed, &quot;skippi&quot;, &quot;https://github.com/skippi&quot;, nil) %Nostrum.Struct.Embed{ author: %Nostrum.Struct.Embed.Author{ name: &quot;skippi&quot;, url: &quot;https://github.com/skippi&quot;, icon_url: nil } }"},{"ref":"Nostrum.Struct.Embed.html#put_color/2","title":"Nostrum.Struct.Embed.put_color/2","type":"function","doc":"Puts the given value under :color in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_color(embed, 431948) %Nostrum.Struct.Embed{color: 431948}"},{"ref":"Nostrum.Struct.Embed.html#put_description/2","title":"Nostrum.Struct.Embed.put_description/2","type":"function","doc":"Puts the given value under :description in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_description(embed, &quot;An elixir library for the discord API.&quot;) %Nostrum.Struct.Embed{description: &quot;An elixir library for the discord API.&quot;}"},{"ref":"Nostrum.Struct.Embed.html#put_field/4","title":"Nostrum.Struct.Embed.put_field/4","type":"function","doc":"Adds a Nostrum.Struct.Embed.Field under :fields in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_field(embed, &quot;First User&quot;, &quot;b1nzy&quot;) %Nostrum.Struct.Embed{ fields: [ %Nostrum.Struct.Embed.Field{name: &quot;First User&quot;, value: &quot;b1nzy&quot;} ] } iex&gt; embed = %Nostrum.Struct.Embed{ ...&gt; fields: [ ...&gt; %Nostrum.Struct.Embed.Field{name: &quot;First User&quot;, value: &quot;b1nzy&quot;} ...&gt; ] ...&gt; } ...&gt; Nostrum.Struct.Embed.put_field(embed, &quot;Second User&quot;, &quot;Danny&quot;) %Nostrum.Struct.Embed{ fields: [ %Nostrum.Struct.Embed.Field{name: &quot;First User&quot;, value: &quot;b1nzy&quot;}, %Nostrum.Struct.Embed.Field{name: &quot;Second User&quot;, value: &quot;Danny&quot;} ] }"},{"ref":"Nostrum.Struct.Embed.html#put_footer/3","title":"Nostrum.Struct.Embed.put_footer/3","type":"function","doc":"Puts a Nostrum.Struct.Embed.Footer under :footer in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_footer(embed, &quot;Discord API&quot;, nil) %Nostrum.Struct.Embed{ footer: %Nostrum.Struct.Embed.Footer{ text: &quot;Discord API&quot;, icon_url: nil } } iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_footer(embed, &quot;nostrum footer&quot;, &quot;https://discordapp.com/assets/53ef346458017da2062aca5c7955946b.svg&quot;) %Nostrum.Struct.Embed{ footer: %Nostrum.Struct.Embed.Footer{ text: &quot;nostrum footer&quot;, icon_url: &quot;https://discordapp.com/assets/53ef346458017da2062aca5c7955946b.svg&quot; } }"},{"ref":"Nostrum.Struct.Embed.html#put_image/2","title":"Nostrum.Struct.Embed.put_image/2","type":"function","doc":"Puts a Nostrum.Struct.Embed.Image under :image in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_image(embed, &quot;https://discordapp.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot;) %Nostrum.Struct.Embed{ image: %Nostrum.Struct.Embed.Image{ url: &quot;https://discordapp.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot; } }"},{"ref":"Nostrum.Struct.Embed.html#put_thumbnail/2","title":"Nostrum.Struct.Embed.put_thumbnail/2","type":"function","doc":"Puts a Nostrum.Struct.Embed.Thumbnail under :thumbnail in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_thumbnail(embed, &quot;https://discordapp.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot;) %Nostrum.Struct.Embed{ thumbnail: %Nostrum.Struct.Embed.Thumbnail{ url: &quot;https://discordapp.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot; } }"},{"ref":"Nostrum.Struct.Embed.html#put_timestamp/2","title":"Nostrum.Struct.Embed.put_timestamp/2","type":"function","doc":"Puts the given value under :timestamp in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_timestamp(embed, &quot;2018-04-21T17:33:51.893000Z&quot;) %Nostrum.Struct.Embed{timestamp: &quot;2018-04-21T17:33:51.893000Z&quot;}"},{"ref":"Nostrum.Struct.Embed.html#put_title/2","title":"Nostrum.Struct.Embed.put_title/2","type":"function","doc":"Puts the given value under :title in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_title(embed, &quot;nostrum&quot;) %Nostrum.Struct.Embed{title: &quot;nostrum&quot;}"},{"ref":"Nostrum.Struct.Embed.html#put_url/2","title":"Nostrum.Struct.Embed.put_url/2","type":"function","doc":"Puts the given value under :url in embed. Examples iex&gt; embed = %Nostrum.Struct.Embed{} ...&gt; Nostrum.Struct.Embed.put_url(embed, &quot;https://github.com/Kraigie/nostrum&quot;) %Nostrum.Struct.Embed{url: &quot;https://github.com/Kraigie/nostrum&quot;}"},{"ref":"Nostrum.Struct.Embed.html#t:author/0","title":"Nostrum.Struct.Embed.author/0","type":"type","doc":"Author information"},{"ref":"Nostrum.Struct.Embed.html#t:color/0","title":"Nostrum.Struct.Embed.color/0","type":"type","doc":"Color code of the embed"},{"ref":"Nostrum.Struct.Embed.html#t:description/0","title":"Nostrum.Struct.Embed.description/0","type":"type","doc":"Description of the embed"},{"ref":"Nostrum.Struct.Embed.html#t:fields/0","title":"Nostrum.Struct.Embed.fields/0","type":"type","doc":"Fields information"},{"ref":"Nostrum.Struct.Embed.html#t:footer/0","title":"Nostrum.Struct.Embed.footer/0","type":"type","doc":"Footer information"},{"ref":"Nostrum.Struct.Embed.html#t:image/0","title":"Nostrum.Struct.Embed.image/0","type":"type","doc":"Image information"},{"ref":"Nostrum.Struct.Embed.html#t:provider/0","title":"Nostrum.Struct.Embed.provider/0","type":"type","doc":"Provider information"},{"ref":"Nostrum.Struct.Embed.html#t:t/0","title":"Nostrum.Struct.Embed.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.html#t:thumbnail/0","title":"Nostrum.Struct.Embed.thumbnail/0","type":"type","doc":"Thumbnail information"},{"ref":"Nostrum.Struct.Embed.html#t:timestamp/0","title":"Nostrum.Struct.Embed.timestamp/0","type":"type","doc":"Timestamp of embed content"},{"ref":"Nostrum.Struct.Embed.html#t:title/0","title":"Nostrum.Struct.Embed.title/0","type":"type","doc":"Title of the embed"},{"ref":"Nostrum.Struct.Embed.html#t:type/0","title":"Nostrum.Struct.Embed.type/0","type":"type","doc":"Type of the embed"},{"ref":"Nostrum.Struct.Embed.html#t:url/0","title":"Nostrum.Struct.Embed.url/0","type":"type","doc":"Url of the embed"},{"ref":"Nostrum.Struct.Embed.html#t:video/0","title":"Nostrum.Struct.Embed.video/0","type":"type","doc":"Video information"},{"ref":"Nostrum.Struct.Embed.Author.html","title":"Nostrum.Struct.Embed.Author","type":"module","doc":"Struct representing a Discord embed author."},{"ref":"Nostrum.Struct.Embed.Author.html#t:icon_url/0","title":"Nostrum.Struct.Embed.Author.icon_url/0","type":"type","doc":"URL of the author icon"},{"ref":"Nostrum.Struct.Embed.Author.html#t:name/0","title":"Nostrum.Struct.Embed.Author.name/0","type":"type","doc":"Name of the author"},{"ref":"Nostrum.Struct.Embed.Author.html#t:proxy_icon_url/0","title":"Nostrum.Struct.Embed.Author.proxy_icon_url/0","type":"type","doc":"Proxied URL of author icon"},{"ref":"Nostrum.Struct.Embed.Author.html#t:t/0","title":"Nostrum.Struct.Embed.Author.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Author.html#t:url/0","title":"Nostrum.Struct.Embed.Author.url/0","type":"type","doc":"URL of the author"},{"ref":"Nostrum.Struct.Embed.Field.html","title":"Nostrum.Struct.Embed.Field","type":"module","doc":"Struct representing a Discord embed field."},{"ref":"Nostrum.Struct.Embed.Field.html#t:inline/0","title":"Nostrum.Struct.Embed.Field.inline/0","type":"type","doc":"Whether the field should display as inline"},{"ref":"Nostrum.Struct.Embed.Field.html#t:name/0","title":"Nostrum.Struct.Embed.Field.name/0","type":"type","doc":"Name of the field"},{"ref":"Nostrum.Struct.Embed.Field.html#t:t/0","title":"Nostrum.Struct.Embed.Field.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Field.html#t:value/0","title":"Nostrum.Struct.Embed.Field.value/0","type":"type","doc":"Value of the field"},{"ref":"Nostrum.Struct.Embed.Footer.html","title":"Nostrum.Struct.Embed.Footer","type":"module","doc":"Struct representing a Discord embed footer."},{"ref":"Nostrum.Struct.Embed.Footer.html#t:icon_url/0","title":"Nostrum.Struct.Embed.Footer.icon_url/0","type":"type","doc":"URL of footer icon"},{"ref":"Nostrum.Struct.Embed.Footer.html#t:proxy_icon_url/0","title":"Nostrum.Struct.Embed.Footer.proxy_icon_url/0","type":"type","doc":"Proxied URL of footer icon"},{"ref":"Nostrum.Struct.Embed.Footer.html#t:t/0","title":"Nostrum.Struct.Embed.Footer.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Footer.html#t:text/0","title":"Nostrum.Struct.Embed.Footer.text/0","type":"type","doc":"Footer text"},{"ref":"Nostrum.Struct.Embed.Image.html","title":"Nostrum.Struct.Embed.Image","type":"module","doc":"Struct representing a Discord embed image."},{"ref":"Nostrum.Struct.Embed.Image.html#t:height/0","title":"Nostrum.Struct.Embed.Image.height/0","type":"type","doc":"Height of the image"},{"ref":"Nostrum.Struct.Embed.Image.html#t:proxy_url/0","title":"Nostrum.Struct.Embed.Image.proxy_url/0","type":"type","doc":"URL of image icon"},{"ref":"Nostrum.Struct.Embed.Image.html#t:t/0","title":"Nostrum.Struct.Embed.Image.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Image.html#t:url/0","title":"Nostrum.Struct.Embed.Image.url/0","type":"type","doc":"Image text"},{"ref":"Nostrum.Struct.Embed.Image.html#t:width/0","title":"Nostrum.Struct.Embed.Image.width/0","type":"type","doc":"Width of the image"},{"ref":"Nostrum.Struct.Embed.Provider.html","title":"Nostrum.Struct.Embed.Provider","type":"module","doc":"Struct representing a Discord embed provider."},{"ref":"Nostrum.Struct.Embed.Provider.html#t:name/0","title":"Nostrum.Struct.Embed.Provider.name/0","type":"type","doc":"Name of the provider"},{"ref":"Nostrum.Struct.Embed.Provider.html#t:t/0","title":"Nostrum.Struct.Embed.Provider.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Provider.html#t:url/0","title":"Nostrum.Struct.Embed.Provider.url/0","type":"type","doc":"URL of provider"},{"ref":"Nostrum.Struct.Embed.Thumbnail.html","title":"Nostrum.Struct.Embed.Thumbnail","type":"module","doc":"Struct representing a Discord embed thumbnail."},{"ref":"Nostrum.Struct.Embed.Thumbnail.html#t:height/0","title":"Nostrum.Struct.Embed.Thumbnail.height/0","type":"type","doc":"Height of the thumbnail"},{"ref":"Nostrum.Struct.Embed.Thumbnail.html#t:proxy_url/0","title":"Nostrum.Struct.Embed.Thumbnail.proxy_url/0","type":"type","doc":"URL of thumbnail icon"},{"ref":"Nostrum.Struct.Embed.Thumbnail.html#t:t/0","title":"Nostrum.Struct.Embed.Thumbnail.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Thumbnail.html#t:url/0","title":"Nostrum.Struct.Embed.Thumbnail.url/0","type":"type","doc":"Source URL of the thumbnail"},{"ref":"Nostrum.Struct.Embed.Thumbnail.html#t:width/0","title":"Nostrum.Struct.Embed.Thumbnail.width/0","type":"type","doc":"Width of the thumbnail"},{"ref":"Nostrum.Struct.Embed.Video.html","title":"Nostrum.Struct.Embed.Video","type":"module","doc":"Struct representing a Discord embed video."},{"ref":"Nostrum.Struct.Embed.Video.html#t:height/0","title":"Nostrum.Struct.Embed.Video.height/0","type":"type","doc":"Height of the video"},{"ref":"Nostrum.Struct.Embed.Video.html#t:t/0","title":"Nostrum.Struct.Embed.Video.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Embed.Video.html#t:url/0","title":"Nostrum.Struct.Embed.Video.url/0","type":"type","doc":"Source URL of the video"},{"ref":"Nostrum.Struct.Embed.Video.html#t:width/0","title":"Nostrum.Struct.Embed.Video.width/0","type":"type","doc":"Width of the video"},{"ref":"Nostrum.Struct.Emoji.html","title":"Nostrum.Struct.Emoji","type":"module","doc":"Struct representing a Discord emoji. Mentioning Emojis in Messages A Nostrum.Struct.Emoji can be mentioned in message content using the String.Chars protocol or mention/1. emoji = %Nostrum.Struct.Emoji{id: 437093487582642177, name: &quot;foxbot&quot;} Nostrum.Api.create_message!(184046599834435585, &quot;\#{emoji}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;:foxbot:437093487582642177&gt;&quot;} emoji = %Nostrum.Struct.Emoji{id: 436885297037312001, name: &quot;tealixir&quot;} Nostrum.Api.create_message!(280085880452939778, &quot;\#{Nostrum.Struct.Emoji.mention(emoji)}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;:tealixir:436885297037312001&gt;&quot;} Using Emojis in the Api A Nostrum.Struct.Emoji can be used in Nostrum.Api by using its api name or the struct itself. emoji = %Nostrum.Struct.Emoji{id: 436885297037312001, name: &quot;tealixir&quot;} Nostrum.Api.create_reaction(381889573426429952, 436247584349356032, Nostrum.Struct.Emoji.api_name(emoji)) {:ok} emoji = %Nostrum.Struct.Emoji{id: 436189601820966923, name: &quot;elixir&quot;} Nostrum.Api.create_reaction(381889573426429952, 436247584349356032, emoji) {:ok} See Nostrum.Struct.Emoji.api_name/0 for more information."},{"ref":"Nostrum.Struct.Emoji.html#api_name/1","title":"Nostrum.Struct.Emoji.api_name/1","type":"function","doc":"Formats an emoji struct into its Nostrum.Struct.Emoji.api_name/0. Examples iex&gt; emoji = %Nostrum.Struct.Emoji{name: &quot;Γ¡É&quot;} ...&gt; Nostrum.Struct.Emoji.api_name(emoji) &quot;Γ¡É&quot; iex&gt; emoji = %Nostrum.Struct.Emoji{id: 437093487582642177, name: &quot;foxbot&quot;} ...&gt; Nostrum.Struct.Emoji.api_name(emoji) &quot;foxbot:437093487582642177&quot;"},{"ref":"Nostrum.Struct.Emoji.html#image_url/1","title":"Nostrum.Struct.Emoji.image_url/1","type":"function","doc":"Returns the url of a custom emoji&#39;s image. If the emoji is not a custom one, returns nil. Examples iex&gt; emoji = %Nostrum.Struct.Emoji{id: 450225070569291776} iex&gt; Nostrum.Struct.Emoji.image_url(emoji) &quot;https://cdn.discordapp.com/emojis/450225070569291776.png&quot; iex&gt; emoji = %Nostrum.Struct.Emoji{id: 406140226998894614, animated: true} iex&gt; Nostrum.Struct.Emoji.image_url(emoji) &quot;https://cdn.discordapp.com/emojis/406140226998894614.gif&quot; iex&gt; emoji = %Nostrum.Struct.Emoji{id: nil, name: &quot;Γ¡É&quot;} iex&gt; Nostrum.Struct.Emoji.image_url(emoji) nil"},{"ref":"Nostrum.Struct.Emoji.html#mention/1","title":"Nostrum.Struct.Emoji.mention/1","type":"function","doc":"Formats an Nostrum.Struct.Emoji into a mention. Examples iex&gt; emoji = %Nostrum.Struct.Emoji{name: &quot;≡ƒæì&quot;} ...&gt; Nostrum.Struct.Emoji.mention(emoji) &quot;≡ƒæì&quot; iex&gt; emoji = %Nostrum.Struct.Emoji{id: 436885297037312001, name: &quot;tealixir&quot;} ...&gt; Nostrum.Struct.Emoji.mention(emoji) &quot;&lt;:tealixir:436885297037312001&gt;&quot; iex&gt; emoji = %Nostrum.Struct.Emoji{id: 437016804309860372, name: &quot;blobseizure&quot;, animated: true} ...&gt; Nostrum.Struct.Emoji.mention(emoji) &quot;&lt;a:blobseizure:437016804309860372&gt;&quot;"},{"ref":"Nostrum.Struct.Emoji.html#t:animated/0","title":"Nostrum.Struct.Emoji.animated/0","type":"type","doc":"Whether this emoji is animated"},{"ref":"Nostrum.Struct.Emoji.html#t:api_name/0","title":"Nostrum.Struct.Emoji.api_name/0","type":"type","doc":"Emoji string to be used with the Discord API. Some API endpoints take an emoji. If it is a custom emoji, it must be structured as &quot;id:name&quot;. If it is an unicode emoji, it can be structured as any of the following: &quot;name&quot; A base 16 unicode emoji string. api_name/1 is a convenience function that returns a Nostrum.Struct.Emoji&#39;s api name. Examples # Custom Emojis &quot;nostrum:431890438091489&quot; # Unicode Emojis &quot;≡ƒæì&quot; &quot;\\xF0\\x9F\\x98\\x81&quot; &quot;\\u2b50&quot;"},{"ref":"Nostrum.Struct.Emoji.html#t:id/0","title":"Nostrum.Struct.Emoji.id/0","type":"type","doc":"Id of the emoji"},{"ref":"Nostrum.Struct.Emoji.html#t:managed/0","title":"Nostrum.Struct.Emoji.managed/0","type":"type","doc":"Whether this emoji is managed"},{"ref":"Nostrum.Struct.Emoji.html#t:name/0","title":"Nostrum.Struct.Emoji.name/0","type":"type","doc":"Name of the emoji"},{"ref":"Nostrum.Struct.Emoji.html#t:require_colons/0","title":"Nostrum.Struct.Emoji.require_colons/0","type":"type","doc":"Whether this emoji must be wrapped in colons"},{"ref":"Nostrum.Struct.Emoji.html#t:roles/0","title":"Nostrum.Struct.Emoji.roles/0","type":"type","doc":"Roles this emoji is whitelisted to"},{"ref":"Nostrum.Struct.Emoji.html#t:t/0","title":"Nostrum.Struct.Emoji.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Emoji.html#t:user/0","title":"Nostrum.Struct.Emoji.user/0","type":"type","doc":"User that created this emoji"},{"ref":"Nostrum.Struct.Event.MessageDelete.html","title":"Nostrum.Struct.Event.MessageDelete","type":"module","doc":"Struct representing a Message Delete event"},{"ref":"Nostrum.Struct.Event.MessageDelete.html#t:channel_id/0","title":"Nostrum.Struct.Event.MessageDelete.channel_id/0","type":"type","doc":"Channel id of the deleted message"},{"ref":"Nostrum.Struct.Event.MessageDelete.html#t:guild_id/0","title":"Nostrum.Struct.Event.MessageDelete.guild_id/0","type":"type","doc":"Guild id of the deleted message nil if a non-guild message was deleted."},{"ref":"Nostrum.Struct.Event.MessageDelete.html#t:id/0","title":"Nostrum.Struct.Event.MessageDelete.id/0","type":"type","doc":"Id of the deleted message"},{"ref":"Nostrum.Struct.Event.MessageDelete.html#t:t/0","title":"Nostrum.Struct.Event.MessageDelete.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Event.MessageDeleteBulk.html","title":"Nostrum.Struct.Event.MessageDeleteBulk","type":"module","doc":"Struct representing a Message Delete Bulk event"},{"ref":"Nostrum.Struct.Event.MessageDeleteBulk.html#t:channel_id/0","title":"Nostrum.Struct.Event.MessageDeleteBulk.channel_id/0","type":"type","doc":"Channel id of the deleted message"},{"ref":"Nostrum.Struct.Event.MessageDeleteBulk.html#t:guild_id/0","title":"Nostrum.Struct.Event.MessageDeleteBulk.guild_id/0","type":"type","doc":"Guild id of the deleted message nil if a non-guild message was deleted."},{"ref":"Nostrum.Struct.Event.MessageDeleteBulk.html#t:ids/0","title":"Nostrum.Struct.Event.MessageDeleteBulk.ids/0","type":"type","doc":"Ids of the deleted messages"},{"ref":"Nostrum.Struct.Event.MessageDeleteBulk.html#t:t/0","title":"Nostrum.Struct.Event.MessageDeleteBulk.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.html","title":"Nostrum.Struct.Guild","type":"module","doc":"Struct representing a Discord guild."},{"ref":"Nostrum.Struct.Guild.html#icon_url/2","title":"Nostrum.Struct.Guild.icon_url/2","type":"function","doc":"Returns the URL of a guild&#39;s icon, or nil if there is no icon. Supported image formats are PNG, JPEG, and WebP. Examples iex&gt; guild = %Nostrum.Struct.Guild{icon: &quot;86e39f7ae3307e811784e2ffd11a7310&quot;, ...&gt; id: 41771983423143937} iex&gt; Nostrum.Struct.Guild.icon_url(guild) &quot;https://cdn.discordapp.com/icons/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.webp&quot; iex&gt; Nostrum.Struct.Guild.icon_url(guild, &quot;png&quot;) &quot;https://cdn.discordapp.com/icons/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.png&quot; iex&gt; guild = %Nostrum.Struct.Guild{icon: nil} iex&gt; Nostrum.Struct.Guild.icon_url(guild) nil"},{"ref":"Nostrum.Struct.Guild.html#splash_url/2","title":"Nostrum.Struct.Guild.splash_url/2","type":"function","doc":"Returns the URL of a guild&#39;s splash, or nil if there is no splash. Supported image formats are PNG, JPEG, and WebP. Examples iex&gt; guild = %Nostrum.Struct.Guild{splash: &quot;86e39f7ae3307e811784e2ffd11a7310&quot;, ...&gt; id: 41771983423143937} iex&gt; Nostrum.Struct.Guild.splash_url(guild) &quot;https://cdn.discordapp.com/splashes/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.webp&quot; iex&gt; Nostrum.Struct.Guild.splash_url(guild, &quot;png&quot;) &quot;https://cdn.discordapp.com/splashes/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.png&quot; iex&gt; guild = %Nostrum.Struct.Guild{splash: nil} iex&gt; Nostrum.Struct.Guild.splash_url(guild) nil"},{"ref":"Nostrum.Struct.Guild.html#t:afk_channel_id/0","title":"Nostrum.Struct.Guild.afk_channel_id/0","type":"type","doc":"The id of the guild&#39;s afk channel"},{"ref":"Nostrum.Struct.Guild.html#t:afk_timeout/0","title":"Nostrum.Struct.Guild.afk_timeout/0","type":"type","doc":"The time someone must be afk before being moved"},{"ref":"Nostrum.Struct.Guild.html#t:application_id/0","title":"Nostrum.Struct.Guild.application_id/0","type":"type","doc":"Application id of the guild creator if it is bot created."},{"ref":"Nostrum.Struct.Guild.html#t:available_guild/0","title":"Nostrum.Struct.Guild.available_guild/0","type":"type","doc":"A Nostrum.Struct.Guild that is fully available."},{"ref":"Nostrum.Struct.Guild.html#t:channels/0","title":"Nostrum.Struct.Guild.channels/0","type":"type","doc":"List of channels"},{"ref":"Nostrum.Struct.Guild.html#t:default_message_notifications/0","title":"Nostrum.Struct.Guild.default_message_notifications/0","type":"type","doc":"Default message notifications level."},{"ref":"Nostrum.Struct.Guild.html#t:embed_channel_id/0","title":"Nostrum.Struct.Guild.embed_channel_id/0","type":"type","doc":"The id of the embedded channel"},{"ref":"Nostrum.Struct.Guild.html#t:embed_enabled/0","title":"Nostrum.Struct.Guild.embed_enabled/0","type":"type","doc":"Whether the guild is emeddable"},{"ref":"Nostrum.Struct.Guild.html#t:emojis/0","title":"Nostrum.Struct.Guild.emojis/0","type":"type","doc":"List of emojis"},{"ref":"Nostrum.Struct.Guild.html#t:explicit_content_filter/0","title":"Nostrum.Struct.Guild.explicit_content_filter/0","type":"type","doc":"Explicit content filter level."},{"ref":"Nostrum.Struct.Guild.html#t:features/0","title":"Nostrum.Struct.Guild.features/0","type":"type","doc":"List of guild features"},{"ref":"Nostrum.Struct.Guild.html#t:icon/0","title":"Nostrum.Struct.Guild.icon/0","type":"type","doc":"The hash of the guild&#39;s icon"},{"ref":"Nostrum.Struct.Guild.html#t:id/0","title":"Nostrum.Struct.Guild.id/0","type":"type","doc":"The guild&#39;s id"},{"ref":"Nostrum.Struct.Guild.html#t:joined_at/0","title":"Nostrum.Struct.Guild.joined_at/0","type":"type","doc":"Date the bot user joined the guild"},{"ref":"Nostrum.Struct.Guild.html#t:large/0","title":"Nostrum.Struct.Guild.large/0","type":"type","doc":"Whether the guild is considered &#39;large&#39;"},{"ref":"Nostrum.Struct.Guild.html#t:member_count/0","title":"Nostrum.Struct.Guild.member_count/0","type":"type","doc":"Total number of members in the guild"},{"ref":"Nostrum.Struct.Guild.html#t:members/0","title":"Nostrum.Struct.Guild.members/0","type":"type","doc":"List of members"},{"ref":"Nostrum.Struct.Guild.html#t:mfa_level/0","title":"Nostrum.Struct.Guild.mfa_level/0","type":"type","doc":"Required MFA level of the guild"},{"ref":"Nostrum.Struct.Guild.html#t:name/0","title":"Nostrum.Struct.Guild.name/0","type":"type","doc":"The name of the guild."},{"ref":"Nostrum.Struct.Guild.html#t:owner_id/0","title":"Nostrum.Struct.Guild.owner_id/0","type":"type","doc":"The id of the guild owner"},{"ref":"Nostrum.Struct.Guild.html#t:region/0","title":"Nostrum.Struct.Guild.region/0","type":"type","doc":"The id of the voice region"},{"ref":"Nostrum.Struct.Guild.html#t:rest_guild/0","title":"Nostrum.Struct.Guild.rest_guild/0","type":"type","doc":"A Nostrum.Struct.Guild that is sent on guild-specific rest endpoints."},{"ref":"Nostrum.Struct.Guild.html#t:roles/0","title":"Nostrum.Struct.Guild.roles/0","type":"type","doc":"List of roles"},{"ref":"Nostrum.Struct.Guild.html#t:splash/0","title":"Nostrum.Struct.Guild.splash/0","type":"type","doc":"The hash of the guild&#39;s splash"},{"ref":"Nostrum.Struct.Guild.html#t:system_channel_id/0","title":"Nostrum.Struct.Guild.system_channel_id/0","type":"type","doc":"The id of the channel to which system messages are sent."},{"ref":"Nostrum.Struct.Guild.html#t:t/0","title":"Nostrum.Struct.Guild.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.html#t:unavailable/0","title":"Nostrum.Struct.Guild.unavailable/0","type":"type","doc":"Whether the guild is avaliable"},{"ref":"Nostrum.Struct.Guild.html#t:unavailable_guild/0","title":"Nostrum.Struct.Guild.unavailable_guild/0","type":"type","doc":"A Nostrum.Struct.Guild that is unavailable."},{"ref":"Nostrum.Struct.Guild.html#t:user_guild/0","title":"Nostrum.Struct.Guild.user_guild/0","type":"type","doc":"A Nostrum.Struct.Guild that is sent on user-specific rest endpoints."},{"ref":"Nostrum.Struct.Guild.html#t:verification_level/0","title":"Nostrum.Struct.Guild.verification_level/0","type":"type","doc":"The level of verification"},{"ref":"Nostrum.Struct.Guild.html#t:voice_states/0","title":"Nostrum.Struct.Guild.voice_states/0","type":"type","doc":"List of voice states as maps"},{"ref":"Nostrum.Struct.Guild.html#t:widget_channel_id/0","title":"Nostrum.Struct.Guild.widget_channel_id/0","type":"type","doc":"The channel id for the server widget."},{"ref":"Nostrum.Struct.Guild.html#t:widget_enabled/0","title":"Nostrum.Struct.Guild.widget_enabled/0","type":"type","doc":"Whether or not the server widget is enabled."},{"ref":"Nostrum.Struct.Guild.AuditLog.html","title":"Nostrum.Struct.Guild.AuditLog","type":"module","doc":"Represents a guild&#39;s audit log."},{"ref":"Nostrum.Struct.Guild.AuditLog.html#t:entries/0","title":"Nostrum.Struct.Guild.AuditLog.entries/0","type":"type","doc":"Entries of this guild&#39;s audit log"},{"ref":"Nostrum.Struct.Guild.AuditLog.html#t:t/0","title":"Nostrum.Struct.Guild.AuditLog.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.AuditLog.html#t:users/0","title":"Nostrum.Struct.Guild.AuditLog.users/0","type":"type","doc":"Users found in the audit log"},{"ref":"Nostrum.Struct.Guild.AuditLog.html#t:webhooks/0","title":"Nostrum.Struct.Guild.AuditLog.webhooks/0","type":"type","doc":"Webhooks found in the audit log"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html","title":"Nostrum.Struct.Guild.AuditLogEntry","type":"module","doc":"Represents a single entry in the guild&#39;s audit log."},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:action_type/0","title":"Nostrum.Struct.Guild.AuditLogEntry.action_type/0","type":"type","doc":"An audit log event identifier. See Audit log events"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:changes/0","title":"Nostrum.Struct.Guild.AuditLogEntry.changes/0","type":"type","doc":"Individual changes of this audit log entry. Change keys are documented here"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:id/0","title":"Nostrum.Struct.Guild.AuditLogEntry.id/0","type":"type","doc":"The ID of this entry"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:options/0","title":"Nostrum.Struct.Guild.AuditLogEntry.options/0","type":"type","doc":"Optional audit entry info"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:reason/0","title":"Nostrum.Struct.Guild.AuditLogEntry.reason/0","type":"type","doc":"The reason for this change, if applicable"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:t/0","title":"Nostrum.Struct.Guild.AuditLogEntry.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:target_id/0","title":"Nostrum.Struct.Guild.AuditLogEntry.target_id/0","type":"type","doc":"The ID of the affected entity"},{"ref":"Nostrum.Struct.Guild.AuditLogEntry.html#t:user_id/0","title":"Nostrum.Struct.Guild.AuditLogEntry.user_id/0","type":"type","doc":"The user who made the changes"},{"ref":"Nostrum.Struct.Guild.Integration.html","title":"Nostrum.Struct.Guild.Integration","type":"module","doc":"Struct representing a Discord guild integration."},{"ref":"Nostrum.Struct.Guild.Integration.Account.html","title":"Nostrum.Struct.Guild.Integration.Account","type":"module","doc":"Struct representing a Discord guild&#39;s integration account."},{"ref":"Nostrum.Struct.Guild.Member.html","title":"Nostrum.Struct.Guild.Member","type":"module","doc":"Struct representing a Discord guild member. A Nostrum.Struct.Guild.Member stores a Nostrum.Struct.User&#39;s properties pertaining to a specific Nostrum.Struct.Guild. Mentioning Members in Messages A Nostrum.Struct.Guild.Member can be mentioned in message content using the String.Chars protocol or mention/1. member = %Nostrum.Struct.Guild.Member{user: Nostrum.Struct.User{id: 120571255635181568}} Nostrum.Api.create_message!(184046599834435585, &quot;\#{member}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;@120571255635181568&gt;&quot;} member = %Nostrum.Struct.Guild.Member{user: Nostrum.Struct.User{id: 89918932789497856}} Nostrum.Api.create_message!(280085880452939778, &quot;\#{Nostrum.Struct.Guild.Member.mention(member)}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;@89918932789497856&gt;&quot;}"},{"ref":"Nostrum.Struct.Guild.Member.html#guild_channel_permissions/3","title":"Nostrum.Struct.Guild.Member.guild_channel_permissions/3","type":"function","doc":"Returns a member&#39;s permissions in a guild channel, based on its Nostrum.Struct.Overwrites. Examples guild = Nostrum.Cache.GuildCache.get!(279093381723062272) member = Map.get(guild.members, 177888205536886784) channel_id = 381889573426429952 Nostrum.Struct.Guild.Member.guild_channel_permissions(member, guild, channel_id) #=&gt; [:manage_messages]"},{"ref":"Nostrum.Struct.Guild.Member.html#guild_permissions/2","title":"Nostrum.Struct.Guild.Member.guild_permissions/2","type":"function","doc":"Returns a member&#39;s guild permissions. Examples guild = Nostrum.Cache.GuildCache.get!(279093381723062272) member = Map.get(guild.members, 177888205536886784) Nostrum.Struct.Guild.Member.guild_permissions(member, guild) #=&gt; [:administrator]"},{"ref":"Nostrum.Struct.Guild.Member.html#mention/1","title":"Nostrum.Struct.Guild.Member.mention/1","type":"function","doc":"Formats a Nostrum.Struct.Guild.Member into a mention. Examples iex&gt; member = %Nostrum.Struct.Guild.Member{user: %Nostrum.Struct.User{id: 177888205536886784}} ...&gt; Nostrum.Struct.Guild.Member.mention(member) &quot;&lt;@177888205536886784&gt;&quot;"},{"ref":"Nostrum.Struct.Guild.Member.html#t:deaf/0","title":"Nostrum.Struct.Guild.Member.deaf/0","type":"type","doc":"Whether the user is deafened. If you dont request offline guild members this field will be nil for any members that come online."},{"ref":"Nostrum.Struct.Guild.Member.html#t:joined_at/0","title":"Nostrum.Struct.Guild.Member.joined_at/0","type":"type","doc":"Date the user joined the guild. If you dont request offline guild members this field will be nil for any members that come online."},{"ref":"Nostrum.Struct.Guild.Member.html#t:mute/0","title":"Nostrum.Struct.Guild.Member.mute/0","type":"type","doc":"Whether the user is muted. If you dont request offline guild members this field will be nil for any members that come online."},{"ref":"Nostrum.Struct.Guild.Member.html#t:nick/0","title":"Nostrum.Struct.Guild.Member.nick/0","type":"type","doc":"The nickname of the user"},{"ref":"Nostrum.Struct.Guild.Member.html#t:roles/0","title":"Nostrum.Struct.Guild.Member.roles/0","type":"type","doc":"A list of role ids"},{"ref":"Nostrum.Struct.Guild.Member.html#t:t/0","title":"Nostrum.Struct.Guild.Member.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.Member.html#t:user/0","title":"Nostrum.Struct.Guild.Member.user/0","type":"type","doc":"The user struct. This field can be nil if the Member struct came as a partial Member object included in a message received from a guild channel."},{"ref":"Nostrum.Struct.Guild.Role.html","title":"Nostrum.Struct.Guild.Role","type":"module","doc":"Struct representing a Discord role. Mentioning Roles in Messages A Nostrum.Struct.Guild.Role can be mentioned in message content using the String.Chars protocol or mention/1. role = %Nostrum.Struct.Guild.Role{id: 431886897539973131} Nostrum.Api.create_message!(184046599834435585, &quot;\#{role}&quot;) %Nostrum.Struct.Message{} role = %Nostrum.Struct.Guild.Role{id: 431884023535632398} Nostrum.Api.create_message!(280085880452939778, &quot;\#{Nostrum.Struct.Guild.Role.mention(role)}&quot;) %Nostrum.Struct.Message{}"},{"ref":"Nostrum.Struct.Guild.Role.html#mention/1","title":"Nostrum.Struct.Guild.Role.mention/1","type":"function","doc":"Formats an Nostrum.Struct.Role into a mention. Examples iex&gt; role = %Nostrum.Struct.Guild.Role{id: 431886639627763722} ...&gt; Nostrum.Struct.Guild.Role.mention(role) &quot;&lt;@&amp;431886639627763722&gt;&quot;"},{"ref":"Nostrum.Struct.Guild.Role.html#t:color/0","title":"Nostrum.Struct.Guild.Role.color/0","type":"type","doc":"The hexadecimal color code"},{"ref":"Nostrum.Struct.Guild.Role.html#t:hoist/0","title":"Nostrum.Struct.Guild.Role.hoist/0","type":"type","doc":"Whether the role is pinned in the user listing"},{"ref":"Nostrum.Struct.Guild.Role.html#t:id/0","title":"Nostrum.Struct.Guild.Role.id/0","type":"type","doc":"The id of the role"},{"ref":"Nostrum.Struct.Guild.Role.html#t:managed/0","title":"Nostrum.Struct.Guild.Role.managed/0","type":"type","doc":"Whether the role is managed by an integration"},{"ref":"Nostrum.Struct.Guild.Role.html#t:mentionable/0","title":"Nostrum.Struct.Guild.Role.mentionable/0","type":"type","doc":"Whether the role is mentionable"},{"ref":"Nostrum.Struct.Guild.Role.html#t:name/0","title":"Nostrum.Struct.Guild.Role.name/0","type":"type","doc":"The name of the role"},{"ref":"Nostrum.Struct.Guild.Role.html#t:permissions/0","title":"Nostrum.Struct.Guild.Role.permissions/0","type":"type","doc":"The permission bit set"},{"ref":"Nostrum.Struct.Guild.Role.html#t:position/0","title":"Nostrum.Struct.Guild.Role.position/0","type":"type","doc":"The position of the role"},{"ref":"Nostrum.Struct.Guild.Role.html#t:t/0","title":"Nostrum.Struct.Guild.Role.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.UnavailableGuild.html","title":"Nostrum.Struct.Guild.UnavailableGuild","type":"module","doc":"Struct representing an unavailable Discord guild."},{"ref":"Nostrum.Struct.Guild.UnavailableGuild.html#to_struct/1","title":"Nostrum.Struct.Guild.UnavailableGuild.to_struct/1","type":"function","doc":""},{"ref":"Nostrum.Struct.Guild.UnavailableGuild.html#t:id/0","title":"Nostrum.Struct.Guild.UnavailableGuild.id/0","type":"type","doc":"The guild&#39;s id"},{"ref":"Nostrum.Struct.Guild.UnavailableGuild.html#t:t/0","title":"Nostrum.Struct.Guild.UnavailableGuild.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Guild.UnavailableGuild.html#t:unavailable/0","title":"Nostrum.Struct.Guild.UnavailableGuild.unavailable/0","type":"type","doc":"Whether the guild is avaliable"},{"ref":"Nostrum.Struct.Invite.html","title":"Nostrum.Struct.Invite","type":"module","doc":"Struct representing a Discord invite."},{"ref":"Nostrum.Struct.Invite.html#t:channel/0","title":"Nostrum.Struct.Invite.channel/0","type":"type","doc":"The channel this invite is for."},{"ref":"Nostrum.Struct.Invite.html#t:code/0","title":"Nostrum.Struct.Invite.code/0","type":"type","doc":"The invite code (unique ID)."},{"ref":"Nostrum.Struct.Invite.html#t:created_at/0","title":"Nostrum.Struct.Invite.created_at/0","type":"type","doc":"When this invite was created."},{"ref":"Nostrum.Struct.Invite.html#t:detailed_invite/0","title":"Nostrum.Struct.Invite.detailed_invite/0","type":"type","doc":"An invite with metadata."},{"ref":"Nostrum.Struct.Invite.html#t:guild/0","title":"Nostrum.Struct.Invite.guild/0","type":"type","doc":"The guild this invite is for."},{"ref":"Nostrum.Struct.Invite.html#t:inviter/0","title":"Nostrum.Struct.Invite.inviter/0","type":"type","doc":"The user who created this invite."},{"ref":"Nostrum.Struct.Invite.html#t:max_age/0","title":"Nostrum.Struct.Invite.max_age/0","type":"type","doc":"Duration (in seconds) after which the invite expires."},{"ref":"Nostrum.Struct.Invite.html#t:max_uses/0","title":"Nostrum.Struct.Invite.max_uses/0","type":"type","doc":"Max number of times this invite can be used."},{"ref":"Nostrum.Struct.Invite.html#t:revoked/0","title":"Nostrum.Struct.Invite.revoked/0","type":"type","doc":"Whether this invite is revoked."},{"ref":"Nostrum.Struct.Invite.html#t:simple_invite/0","title":"Nostrum.Struct.Invite.simple_invite/0","type":"type","doc":"An invite without metadata."},{"ref":"Nostrum.Struct.Invite.html#t:t/0","title":"Nostrum.Struct.Invite.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Invite.html#t:temporary/0","title":"Nostrum.Struct.Invite.temporary/0","type":"type","doc":"Whether this invite only grants temporary membership."},{"ref":"Nostrum.Struct.Invite.html#t:uses/0","title":"Nostrum.Struct.Invite.uses/0","type":"type","doc":"Number of times this invite has been used."},{"ref":"Nostrum.Struct.Message.html","title":"Nostrum.Struct.Message","type":"module","doc":"Struct representing a Discord message."},{"ref":"Nostrum.Struct.Message.html#t:activity/0","title":"Nostrum.Struct.Message.activity/0","type":"type","doc":"The activity of the message. Sent with Rich Presence-related chat embeds."},{"ref":"Nostrum.Struct.Message.html#t:application/0","title":"Nostrum.Struct.Message.application/0","type":"type","doc":"The application of the message. Sent with Rich Presence-related chat embeds."},{"ref":"Nostrum.Struct.Message.html#t:attachments/0","title":"Nostrum.Struct.Message.attachments/0","type":"type","doc":"List of attached files in the message"},{"ref":"Nostrum.Struct.Message.html#t:author/0","title":"Nostrum.Struct.Message.author/0","type":"type","doc":"The user struct of the author"},{"ref":"Nostrum.Struct.Message.html#t:channel_id/0","title":"Nostrum.Struct.Message.channel_id/0","type":"type","doc":"The id of the channel"},{"ref":"Nostrum.Struct.Message.html#t:content/0","title":"Nostrum.Struct.Message.content/0","type":"type","doc":"The content of the message"},{"ref":"Nostrum.Struct.Message.html#t:edited_timestamp/0","title":"Nostrum.Struct.Message.edited_timestamp/0","type":"type","doc":"When the message was edited"},{"ref":"Nostrum.Struct.Message.html#t:embeds/0","title":"Nostrum.Struct.Message.embeds/0","type":"type","doc":"List of embedded content in the message"},{"ref":"Nostrum.Struct.Message.html#t:guild_id/0","title":"Nostrum.Struct.Message.guild_id/0","type":"type","doc":"The id of the guild"},{"ref":"Nostrum.Struct.Message.html#t:id/0","title":"Nostrum.Struct.Message.id/0","type":"type","doc":"The id of the message"},{"ref":"Nostrum.Struct.Message.html#t:member/0","title":"Nostrum.Struct.Message.member/0","type":"type","doc":"Partial Guild Member object received with the Message Create event if message came from a guild channel."},{"ref":"Nostrum.Struct.Message.html#t:mention_everyone/0","title":"Nostrum.Struct.Message.mention_everyone/0","type":"type","doc":"Whether this messsage mentions everyone"},{"ref":"Nostrum.Struct.Message.html#t:mention_roles/0","title":"Nostrum.Struct.Message.mention_roles/0","type":"type","doc":"List of roles ids mentioned in the message"},{"ref":"Nostrum.Struct.Message.html#t:mentions/0","title":"Nostrum.Struct.Message.mentions/0","type":"type","doc":"List of users mentioned in the message"},{"ref":"Nostrum.Struct.Message.html#t:nonce/0","title":"Nostrum.Struct.Message.nonce/0","type":"type","doc":"Validates if a message was sent"},{"ref":"Nostrum.Struct.Message.html#t:pinned/0","title":"Nostrum.Struct.Message.pinned/0","type":"type","doc":"Whether this message is pinned"},{"ref":"Nostrum.Struct.Message.html#t:reactions/0","title":"Nostrum.Struct.Message.reactions/0","type":"type","doc":"Reactions to the message."},{"ref":"Nostrum.Struct.Message.html#t:t/0","title":"Nostrum.Struct.Message.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Message.html#t:timestamp/0","title":"Nostrum.Struct.Message.timestamp/0","type":"type","doc":"When the message was sent"},{"ref":"Nostrum.Struct.Message.html#t:tts/0","title":"Nostrum.Struct.Message.tts/0","type":"type","doc":"Whether this was a TTS message"},{"ref":"Nostrum.Struct.Message.html#t:type/0","title":"Nostrum.Struct.Message.type/0","type":"type","doc":"Type of message."},{"ref":"Nostrum.Struct.Message.html#t:webhook_id/0","title":"Nostrum.Struct.Message.webhook_id/0","type":"type","doc":"If the message is generated by a webhook, this is the webhook&#39;s id."},{"ref":"Nostrum.Struct.Message.Activity.html","title":"Nostrum.Struct.Message.Activity","type":"module","doc":"Struct representing a Discord message activity."},{"ref":"Nostrum.Struct.Message.Activity.html#t:party_id/0","title":"Nostrum.Struct.Message.Activity.party_id/0","type":"type","doc":"The party id from a rich presence event."},{"ref":"Nostrum.Struct.Message.Activity.html#t:t/0","title":"Nostrum.Struct.Message.Activity.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Message.Activity.html#t:type/0","title":"Nostrum.Struct.Message.Activity.type/0","type":"type","doc":"Type of message activity."},{"ref":"Nostrum.Struct.Message.Application.html","title":"Nostrum.Struct.Message.Application","type":"module","doc":"Struct representing a Discord message application."},{"ref":"Nostrum.Struct.Message.Application.html#t:cover_image/0","title":"Nostrum.Struct.Message.Application.cover_image/0","type":"type","doc":"Id of the embed&#39;s image asset"},{"ref":"Nostrum.Struct.Message.Application.html#t:description/0","title":"Nostrum.Struct.Message.Application.description/0","type":"type","doc":"Application&#39;s description"},{"ref":"Nostrum.Struct.Message.Application.html#t:icon/0","title":"Nostrum.Struct.Message.Application.icon/0","type":"type","doc":"Id of the application&#39;s icon"},{"ref":"Nostrum.Struct.Message.Application.html#t:id/0","title":"Nostrum.Struct.Message.Application.id/0","type":"type","doc":"Id of the application"},{"ref":"Nostrum.Struct.Message.Application.html#t:name/0","title":"Nostrum.Struct.Message.Application.name/0","type":"type","doc":"Name of the application"},{"ref":"Nostrum.Struct.Message.Application.html#t:t/0","title":"Nostrum.Struct.Message.Application.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Message.Attachment.html","title":"Nostrum.Struct.Message.Attachment","type":"module","doc":"Struct representing a Discord message attachment."},{"ref":"Nostrum.Struct.Message.Attachment.html#t:filename/0","title":"Nostrum.Struct.Message.Attachment.filename/0","type":"type","doc":"Name of attached file"},{"ref":"Nostrum.Struct.Message.Attachment.html#t:height/0","title":"Nostrum.Struct.Message.Attachment.height/0","type":"type","doc":"Height of the file (if image)"},{"ref":"Nostrum.Struct.Message.Attachment.html#t:id/0","title":"Nostrum.Struct.Message.Attachment.id/0","type":"type","doc":"Attachment id"},{"ref":"Nostrum.Struct.Message.Attachment.html#t:proxy_url/0","title":"Nostrum.Struct.Message.Attachment.proxy_url/0","type":"type","doc":"Proxy url of the file"},{"ref":"Nostrum.Struct.Message.Attachment.html#t:size/0","title":"Nostrum.Struct.Message.Attachment.size/0","type":"type","doc":"Size of the file in bytes"},{"ref":"Nostrum.Struct.Message.Attachment.html#t:t/0","title":"Nostrum.Struct.Message.Attachment.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Message.Attachment.html#t:url/0","title":"Nostrum.Struct.Message.Attachment.url/0","type":"type","doc":"Source url of the file"},{"ref":"Nostrum.Struct.Message.Attachment.html#t:width/0","title":"Nostrum.Struct.Message.Attachment.width/0","type":"type","doc":"Width of the file (if image)"},{"ref":"Nostrum.Struct.Message.Reaction.html","title":"Nostrum.Struct.Message.Reaction","type":"module","doc":"Struct representing a Discord message reaction."},{"ref":"Nostrum.Struct.Message.Reaction.html#t:count/0","title":"Nostrum.Struct.Message.Reaction.count/0","type":"type","doc":"Times this emoji has been used to react"},{"ref":"Nostrum.Struct.Message.Reaction.html#t:emoji/0","title":"Nostrum.Struct.Message.Reaction.emoji/0","type":"type","doc":"Emoji information"},{"ref":"Nostrum.Struct.Message.Reaction.html#t:me/0","title":"Nostrum.Struct.Message.Reaction.me/0","type":"type","doc":"Whether the current user is the one who reacted"},{"ref":"Nostrum.Struct.Message.Reaction.html#t:t/0","title":"Nostrum.Struct.Message.Reaction.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Overwrite.html","title":"Nostrum.Struct.Overwrite","type":"module","doc":"Struct representing a Discord overwrite."},{"ref":"Nostrum.Struct.Overwrite.html#t:allow/0","title":"Nostrum.Struct.Overwrite.allow/0","type":"type","doc":"Permission bit set"},{"ref":"Nostrum.Struct.Overwrite.html#t:deny/0","title":"Nostrum.Struct.Overwrite.deny/0","type":"type","doc":"Permission bit set"},{"ref":"Nostrum.Struct.Overwrite.html#t:id/0","title":"Nostrum.Struct.Overwrite.id/0","type":"type","doc":"Role or User id"},{"ref":"Nostrum.Struct.Overwrite.html#t:t/0","title":"Nostrum.Struct.Overwrite.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Overwrite.html#t:type/0","title":"Nostrum.Struct.Overwrite.type/0","type":"type","doc":"Either &#39;role&#39; or &#39;member&#39;"},{"ref":"Nostrum.Struct.User.html","title":"Nostrum.Struct.User","type":"module","doc":"Struct representing a Discord user. Mentioning Users in Messages A Nostrum.Struct.User can be mentioned in message content using the String.Chars protocol or mention/1. user = %Nostrum.Struct.User{id: 120571255635181568} Nostrum.Api.create_message!(184046599834435585, &quot;\#{user}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;@120571255635181568&gt;&quot;} user = %Nostrum.Struct.User{id: 89918932789497856} Nostrum.Api.create_message!(280085880452939778, &quot;\#{Nostrum.Struct.User.mention(user)}&quot;) %Nostrum.Struct.Message{content: &quot;&lt;@89918932789497856&gt;&quot;} User vs. Member A user contains only general information about that user such as a username and an avatar. A member has everything that a user has, but also additional information on a per guild basis. This includes things like a nickname and a list of roles."},{"ref":"Nostrum.Struct.User.html#avatar_url/2","title":"Nostrum.Struct.User.avatar_url/2","type":"function","doc":"Returns the URL of a user&#39;s display avatar. If :avatar is nil, the default avatar url is returned. Supported image formats are PNG, JPEG, WebP, and GIF. Examples iex&gt; user = %Nostrum.Struct.User{avatar: &quot;8342729096ea3675442027381ff50dfe&quot;, ...&gt; id: 80351110224678912} iex&gt; Nostrum.Struct.User.avatar_url(user) &quot;https://cdn.discordapp.com/avatars/80351110224678912/8342729096ea3675442027381ff50dfe.webp&quot; iex&gt; Nostrum.Struct.User.avatar_url(user, &quot;png&quot;) &quot;https://cdn.discordapp.com/avatars/80351110224678912/8342729096ea3675442027381ff50dfe.png&quot; iex&gt; user = %Nostrum.Struct.User{avatar: nil, ...&gt; discriminator: &quot;1337&quot;} iex&gt; Nostrum.Struct.User.avatar_url(user) &quot;https://cdn.discordapp.com/embed/avatars/2.png&quot;"},{"ref":"Nostrum.Struct.User.html#full_name/1","title":"Nostrum.Struct.User.full_name/1","type":"function","doc":"Returns a user&#39;s :username and :discriminator separated by a hashtag. Examples iex&gt; user = %Nostrum.Struct.User{username: &quot;b1nzy&quot;, ...&gt; discriminator: &quot;0852&quot;} iex&gt; Nostrum.Struct.User.full_name(user) &quot;b1nzy#0852&quot;"},{"ref":"Nostrum.Struct.User.html#mention/1","title":"Nostrum.Struct.User.mention/1","type":"function","doc":"Formats an Nostrum.Struct.User into a mention. Examples iex&gt; user = %Nostrum.Struct.User{id: 177888205536886784} ...&gt; Nostrum.Struct.User.mention(user) &quot;&lt;@177888205536886784&gt;&quot;"},{"ref":"Nostrum.Struct.User.html#t:avatar/0","title":"Nostrum.Struct.User.avatar/0","type":"type","doc":"User&#39;s avatar hash"},{"ref":"Nostrum.Struct.User.html#t:bot/0","title":"Nostrum.Struct.User.bot/0","type":"type","doc":"Whether the user is a bot"},{"ref":"Nostrum.Struct.User.html#t:discriminator/0","title":"Nostrum.Struct.User.discriminator/0","type":"type","doc":"The user&#39;s 4--digit discord-tag"},{"ref":"Nostrum.Struct.User.html#t:email/0","title":"Nostrum.Struct.User.email/0","type":"type","doc":"The user&#39;s email"},{"ref":"Nostrum.Struct.User.html#t:id/0","title":"Nostrum.Struct.User.id/0","type":"type","doc":"The user&#39;s id"},{"ref":"Nostrum.Struct.User.html#t:mfa_enabled/0","title":"Nostrum.Struct.User.mfa_enabled/0","type":"type","doc":"Whether the user has two factor enabled"},{"ref":"Nostrum.Struct.User.html#t:t/0","title":"Nostrum.Struct.User.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.User.html#t:username/0","title":"Nostrum.Struct.User.username/0","type":"type","doc":"The user&#39;s username"},{"ref":"Nostrum.Struct.User.html#t:verified/0","title":"Nostrum.Struct.User.verified/0","type":"type","doc":"Whether the email on the account has been verified"},{"ref":"Nostrum.Struct.User.Connection.html","title":"Nostrum.Struct.User.Connection","type":"module","doc":"Struct representing a Discord User&#39;s connections"},{"ref":"Nostrum.Struct.VoiceRegion.html","title":"Nostrum.Struct.VoiceRegion","type":"module","doc":"Struct representing a Discord voice region."},{"ref":"Nostrum.Struct.WSState.html","title":"Nostrum.Struct.WSState","type":"module","doc":"Struct representing the current WS state."},{"ref":"Nostrum.Struct.WSState.html#t:conn/0","title":"Nostrum.Struct.WSState.conn/0","type":"type","doc":"PID of the :gun worker connected to the websocket"},{"ref":"Nostrum.Struct.WSState.html#t:conn_pid/0","title":"Nostrum.Struct.WSState.conn_pid/0","type":"type","doc":"PID of the connection process"},{"ref":"Nostrum.Struct.WSState.html#t:gateway/0","title":"Nostrum.Struct.WSState.gateway/0","type":"type","doc":"Gateway URL"},{"ref":"Nostrum.Struct.WSState.html#t:heartbeat_ack/0","title":"Nostrum.Struct.WSState.heartbeat_ack/0","type":"type","doc":"Whether or not the last hearbeat sent was ACK&#39;d"},{"ref":"Nostrum.Struct.WSState.html#t:heartbeat_interval/0","title":"Nostrum.Struct.WSState.heartbeat_interval/0","type":"type","doc":"Interval at which heartbeats are sent"},{"ref":"Nostrum.Struct.WSState.html#t:heartbeat_ref/0","title":"Nostrum.Struct.WSState.heartbeat_ref/0","type":"type","doc":"Time ref for the heartbeat"},{"ref":"Nostrum.Struct.WSState.html#t:last_heartbeat_ack/0","title":"Nostrum.Struct.WSState.last_heartbeat_ack/0","type":"type","doc":"The time the last heartbeat was acknowledged, will be nil if a heartbeat hasn&#39;t been ACK&#39;d yet"},{"ref":"Nostrum.Struct.WSState.html#t:last_heartbeat_send/0","title":"Nostrum.Struct.WSState.last_heartbeat_send/0","type":"type","doc":"The time the last heartbeat was sent, if a heartbeat hasn&#39;t been sent it will be the time the websocket process was started"},{"ref":"Nostrum.Struct.WSState.html#t:seq/0","title":"Nostrum.Struct.WSState.seq/0","type":"type","doc":"The sequence number of the last event"},{"ref":"Nostrum.Struct.WSState.html#t:session/0","title":"Nostrum.Struct.WSState.session/0","type":"type","doc":"The session id"},{"ref":"Nostrum.Struct.WSState.html#t:shard_num/0","title":"Nostrum.Struct.WSState.shard_num/0","type":"type","doc":"The shard number"},{"ref":"Nostrum.Struct.WSState.html#t:shard_pid/0","title":"Nostrum.Struct.WSState.shard_pid/0","type":"type","doc":"PID of the shard containing this state"},{"ref":"Nostrum.Struct.WSState.html#t:t/0","title":"Nostrum.Struct.WSState.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.WSState.html#t:zlib_ctx/0","title":"Nostrum.Struct.WSState.zlib_ctx/0","type":"type","doc":"Reference to the current zlib context"},{"ref":"Nostrum.Struct.Webhook.html","title":"Nostrum.Struct.Webhook","type":"module","doc":"Struct representing a Discord webhook."},{"ref":"Nostrum.Struct.Webhook.html#t:avatar/0","title":"Nostrum.Struct.Webhook.avatar/0","type":"type","doc":"Default avatar of the webhook"},{"ref":"Nostrum.Struct.Webhook.html#t:channel_id/0","title":"Nostrum.Struct.Webhook.channel_id/0","type":"type","doc":"Channel the webhook is for"},{"ref":"Nostrum.Struct.Webhook.html#t:guild_id/0","title":"Nostrum.Struct.Webhook.guild_id/0","type":"type","doc":"Guild the webhook is for"},{"ref":"Nostrum.Struct.Webhook.html#t:id/0","title":"Nostrum.Struct.Webhook.id/0","type":"type","doc":"Id of the webhook"},{"ref":"Nostrum.Struct.Webhook.html#t:name/0","title":"Nostrum.Struct.Webhook.name/0","type":"type","doc":"Default name of the webhook"},{"ref":"Nostrum.Struct.Webhook.html#t:t/0","title":"Nostrum.Struct.Webhook.t/0","type":"type","doc":""},{"ref":"Nostrum.Struct.Webhook.html#t:token/0","title":"Nostrum.Struct.Webhook.token/0","type":"type","doc":"Secure token of the webhook"},{"ref":"Nostrum.Struct.Webhook.html#t:user/0","title":"Nostrum.Struct.Webhook.user/0","type":"type","doc":"User who created the webhook"},{"ref":"intro.html","title":"Intro","type":"extras","doc":"Intro Nostrum is a an Elixir library that can be used to interact with Discord. Nostrum currently supports the latest stable version of Elixir, v. 1.7. With a platform like Discord, there are many moving parts and an attempt was made to break these parts into smaller logical pieces. To see documentation about a specific part of the library, please visit one of the following - API - Methods to interact with the RESTful API (and some other goodies). State - Caches that hold the state of Discord that your bot can see. Events - How you can handle real time events that your bot can see. Custom Consumers - Information on defining custom consumer processes. Why Elixir? From the Elixir website - Elixir is a dynamic, functional language designed for building scalable and maintainable applications. Elixir leverages the Erlang VM, known for running low-latency, distributed and fault-tolerant systems, while also being successfully used in web development and the embedded software domain. How does Nostrum leverage these benefits? Fault tolerance - Nostrum attempts, where reasonable, to allow for different parts of the application to fail with minimal harm. Supervisors are used heavily to ensure that anything that breaks will be restarted. Nostrum attempts to avoid most errors, but if they do occur (and they will!) it shouldn&#39;t be the end of the world. Concurrency - Concurrency is considered to be a first class citizen in Elixir. Through the use of SMP and processes, information should travel through the application quickly. Distributed - Nostrum does not currently supported any sort of Distributed mode out of the box. By default everything is ran on the one node that you launch the application from. I&#39;m open to suggestions as to how Nostrum could leverage being spread across many nodes. Usage There are two versions of Nostrum, a stable version released on Hex and a dev version on GitHub. The dev version will be more up to date but will likely have more errors. Add Nostrum as a dependency: Stable def deps do [{:nostrum, &quot;~&gt; 0.4&quot;}] end Dev def deps do [{:nostrum, git: &quot;https://github.com/Kraigie/nostrum.git&quot;}] end Edit or create your config file: The file should be located at /config/config.exs. To run Nostrum you need the following two fields: config :nostrum, token: 666, # The token of your bot as a string num_shards: 2 # The number of shards you want to run your bot under, or :auto. If you don&#39;t know what num_shards is or don&#39;t have your bot on a lot of guilds you can omit the field and it will default to 1. You can also set this option to :auto and Nostrum will automatically get the recommended number of shards. The following fields are also supported: dev - This is added to enable Nostrum to be run completely stand alone for development purposes. true will cause Nostrum to spawn its own event consumers. If you have the dev flag set to true while running Nostrum alongside your application some of your events will be consumed. Defaults to false. log_full_events - This will log the full payload received over the websocket. This is included primarily for debugging and testing purposes. Defaults to false. log_dispatch_events - This will log dispatch events as they are received from the gateway. This is included primarily for debugging and testing purposes. Defaults to false. custom_consumer - For use when creating custom consumer processes. This disables all caching done internally, in lieu of sending dispatch events to the processes you specify. For more information see creating custom consumers. Defaults to false. request_guild_members - This will perform member chunking to retrieve a complete list of members for all guilds. This will increase start up time and memory usage by quite a bit. Defaults to false. fullsweep_after_default - Sets the fullsweep_after flag for processes that can have irregularly high memory usage due to Discord payloads. This options will dramatically reduce the amount of memory used by some processes at the cost of increased CPU usage. This is useful if you&#39;re running your application under a memory constrained environment. This comes at the cost of increased CPU usage. By default, this option will only affect some processes. You can set this flag for all processes using environment variables or by setting the system flag yourself. Defaults to whatever your system recommends, which is probably 65535. By default, Nostrum logs a lot of data using Logger. If you want to ignore Logger debug data, include the following: config :logger, level: :warn Nostrum exposes the following metadata fields through logger: shard - Id of the shard on which the event occured To enable this metadata, logger can be configured as such: config :logger, :console, metadata: [:shard] For more information on how this works, please see the Logger documentation Nostrum takes advantage of :debug, :warn, and :info. Example Bot A very simple example bot can be found here. A more complex bot can be found here."},{"ref":"api.html","title":"Api","type":"extras","doc":"Api Nostrum includes a complete implementation of the endpoints supported by Discord&#39;s API. Method names are copied closely from the documentation to eliminate any confusion about what a method does, as well as allow users to easily lookup the endpoints in the official API documentation. For a full listing of method definitions, please see Nostrum.Api"},{"ref":"api.html#what-does-the-mean","title":"Api - What does the &#39;!&#39; mean?","type":"extras","doc":"(soon™) All methods have a banged version of themselves. This is a common Elixir idiom hailing from Elixir&#39;s style of failing fast. By default, the API method will return a tuple like one of the following: # Success {:ok, msg} = Nostrum.Api.create_message(179679229036724225, &quot;456&quot;) # Failure {:error, reason} = Nostrum.Api.create_message(123, &quot;eat my shorts api&quot;) A banged method, instead of returning an error tuple, will throw an error. If successful, it will directly return the response with no :ok tuple. # Success msg = Nostrum.Api.create_message!(179679229036724225, &quot;456&quot;) # Failure - Throws an error Nostrum.Api.create_message!(123, &quot;eat my shorts api&quot;)"},{"ref":"api.html#helpers","title":"Api - Helpers","type":"extras","doc":"When appropriate, some helpers are defined to make interacting with the API simpler. An example of this is Nostrum.Api.get_channel_messages/3. By default this endpoint only allows the retrieval of 100 messages at a time. A general use case will have a user wanting more messages than that, thus Nostrum handles the retrieval of any number of messages for the user. There are other endpoints that could use grooming like above, feel free to suggest an interface and implementation for these methods."},{"ref":"api.html#ratelimiting","title":"Api - Ratelimiting","type":"extras","doc":"Ratelimiting is handled internally by Nostrum, so long as you use the methods supplied in the Nostrum.Api module. This means either calling the methods as they&#39;re given or using Nostrum.Api.request/4 to call an endpoint. To ensure that every request is handled properly, no matter if they&#39;re called asynchronously or not, Nostrum funnels all requests through a single GenServer. The ratelimiter at a high level works something like this: Request is sent to the serializer Serializer checks to see if there&#39;s a current block on that endpoint. If there is a block, the pid of the caller is stored, and a task is started to try the call again after a specified time stored from previous calls. If the request goes through, the headers are processed to see if a block should be instantiated for that endpoint."},{"ref":"api.html#rest-only","title":"Api - Rest Only","type":"extras","doc":"If you only want to use the REST portion of the provided API, the only process needed is the ratelimiter. This can be manually started by calling Nostrum.Api.Ratelimiter.start_link/1. If you don&#39;t want to start Nostrum you can add runtime: false to the dependency options."},{"ref":"state.html","title":"State","type":"extras","doc":"State Nostrum keeps track of the state that your bot can see. This state is updated based on events from the WS connection. Most of the cache modules support only simple interactions with the cache. Feel free to suggest additional functionality."},{"ref":"state.html#structs","title":"State - Structs","type":"extras","doc":"Nostrum uses structs when appropriate to pass around objects from Discord. In some cases, the struct modules will include helper functions for interacting with the struct. See Nostrum.Struct.Emoji.image_url/1 for an example."},{"ref":"state.html#guilds","title":"State - Guilds","type":"extras","doc":"Each guild is ran in its own GenServer process, all of which are ran under a supervisor. Behind the scenes, Nostrum uses the Registry module to map guild ids to a pid to allow for lookup. Please see Nostrum.Cache.GuildCache for more information on interacting with guilds."},{"ref":"state.html#channels","title":"State - Channels","type":"extras","doc":"DM channels are all stored in a single map in a single GenServer. Guild channels are stored in their respective guilds. Channels aren&#39;t important enough to have their own process per channel, and the current implementation is not done well, in the future this will likely be moved to an ETS backed cache like users are, but the interface will remain the same. Please see Nostrum.Cache.ChannelCache for more information on interacting with channels. Though they&#39;re stored in different places, the interface hides that fact."},{"ref":"state.html#users","title":"State - Users","type":"extras","doc":"Users are all stored in an ETS table, keyed off of their id. To see the name of the ETS table associated with the user cache, and examples of interacting with it both directly and through the provided abstractions, please see Nostrum.Cache.UserCache."},{"ref":"state.html#mappings","title":"State - Mappings","type":"extras","doc":"There are some use cases where given a channel_id or guild_id we may want to find the guild or shard that the id belongs to. For this purpose Nostrum stores these types of relations in ETS tables. The following mappings exists. guild_channel_id -&gt; guild_id guild_id -&gt; shard_num shard_num_num -&gt; shard_pid Please see Nostrum.Cache.Mapping.ChannelGuild for one such map."},{"ref":"events.html","title":"Events","type":"extras","doc":"Events Event handling is how your bot application will interact with the information sent from Discord over a websocket connection. By defining an event handler for an event, when something like a message is created or a channel is deleted, your application can perform an action as a result of that event. Nostrum currently uses a GenStage implementation to handle dispatching events from the WS connection. To handle events it is up to you to define the consumer of the GenStage life cycle. To see the documentation on using one of provided consumers, please see Nostrum.Consumer."},{"ref":"events.html#why-genstage","title":"Events - Why GenStage?","type":"extras","doc":"From the GenStage docs: GenStage is a specification for exchanging events between producers and consumers. Sounds a lot like the use case here, doesn&#39;t it? An earlier implementation sent the dispatch events from the websocket directly to user defined handlers inside of a task. This was okay, but it made handling the events internally a bit difficult as we would either need to block the main shard process or daisy chain tasks together. We could use a simple GenServer approach, but at that point, why not just use GenStage? GenStage uses GenServer behind the scenes, but abstracts away dispatching the data and providing back-pressure. With the GenStage approach we have an OTP implementation of our required behaviour that gives us separate maintainable parts with back-pressure."},{"ref":"events.html#implementation-details","title":"Events - Implementation Details","type":"extras","doc":"The following information will define the general procedure of dispatching events. If you disagree with anything listed below or would like to offer a suggestion on how it can be improved, please feel free to voice your opinion. Shard Every shard in the Nostrum application is ran as its own process. These shards are all run under the same supervisor. As part of the setup for each shard, it creates its own producer under a supervisor. As events are sent to the shard, the following happens: Shard looks to see what type of event it is, only dispatch events are sent to the producer. If the event is a Dispatch, the payload is converted to an atom-keyed map. This is done because over ETF (which Nostrum uses), map keys are sometimes binaries and sometimes strings, making it a real headache. Additionally, with atom keys, we can use the Map.key notation. This is normally considered unsafe but a debug messages will be emitted if a key is unsafely converted to an atom. In this way we can ensure that our atom table is not growing unbounded. The payload is then sent to the relevant cache to update its state inside of a supervised task. The cache sends the curated payload information to the producer. In the case of updates, the cache will sometimes send two payloads back, the old and the new payload, for comparison purposes. In general, the payload will often match the payload described by the official Discord API documentation. Producer The producer is responsible for queuing up events to dispatch, as well as dispatching these events. The producer takes the payload(s) and puts them into a queue of events to send to a consumer. Consumer The consumer is implemented by the user. They can spawn any number of consumers which will in turn request events from the producers created by each shard. Nostrum wraps the GenStage module to provide a simpler interface for event handling. One of the benefits to this approach is that we can abstract away the manual linking of producer to consumer. For creating your own custom consumers, please see here."},{"ref":"consumers.html","title":"Consumers","type":"extras","doc":""},{"ref":"consumers.html#consumers","title":"Consumers - Consumers","type":"extras","doc":"Nostrum uses GenStage for event dispatching. A consumer is provided by the library in the form of Nostrum.Consumer. This provided process abstracts most of the &quot;work&quot; of defining consumers away from the user. With this consumer everything is handled including maintaining all of the internal caches. That said, it is still possible to define your own consumers, bypassing maintaining state within the lib itself."},{"ref":"consumers.html#implementing-custom-consumers","title":"Consumers - Implementing Custom Consumers","type":"extras","doc":"To implement your own custom consumer you need to enable the option in your config. To do so, simply add custom_consumer: false to your config. To find the pids of the producers you need to subscribe to, you can use the method Nostrum.Util.producers/0."}]